

;----------------------------------------------------------------------------
; Crossfire v1.1b
;
; Copyright(C) Kollar Zoltan, 2005.
;
;----------------------------------------------------------------------------


keyboard        =       03800h                  ;Billentyuzet terulet

;--------------------------------------------------------------------
;Page 0 : bazis es ellenseg sprite-ok, score sor
;Page 1 : Lovedekek, hazak, game over es pause text
;--------------------------------------------------------------------
graph.page0     =       08000h                  ;Micolor page 0 (16K)
graph.page1     =       08000h                  ;Micolor page 1 (16K)

;--------------------------------------------------------------------
; Palette: A ket lap egymason jelenik meg. A sprite-ok atusztatasa a
; hatteren (lovedek, szoveg) a szinek kialakitasaval van megoldva:
;
; 00 00 : fekete   01 00 : piros
; xx 01 : cian     10 00 : szurke
; xx 02 : piros    11 00 : feher
; xx 03 : feher
;
; Igy kialakitva a sprite szinei fuggetlenek a hattertol es ugy nez
; ki, mintha felette lenne
;--------------------------------------------------------------------
palette.reg     =       0A0h                    ;szinregiszterek (16)
shift.reg       =       080h                    ;kep shift regiszterek (4)

speaker         =       06h                     ;Kazetta 1 hangkimenet

;--------------------------------------------------------------------
; Billentyuzet: az egyes sorokon belul a bill. bitszamai
;--------------------------------------------------------------------
fire.up         =       5                       ; <E>
fire.down       =       4                       ; <D>
fire.left       =       3                       ; <S>
fire.right      =       6                       ; <F>

move.up         =       1                       ; <I>
move.down       =       3                       ; <K>
move.left       =       2                       ; <J>
move.right      =       4                       ; <L>
move.stop       =       7                       ; <Space>

;--------------------------------------------------------------------
; Nehany parameter
;--------------------------------------------------------------------
max.enemy       =       6       ;Egyszerre mozgathato ellensegek szama
restartdelay    =       64      ;A palya ujrainditasa elott meg hagyja
                                ;mozogni az ellensegeket
startammo       =       40      ;Kezdeti loszerek szama. Minden palyan
                                ;csokkenti 4-el.
min.ammo        =       16      ;Minimum ennyi loszert azert ad

;----------------------------------------------------------------------------

                org     4000h

;Program start: rendszer alaphelyzetbeallitasa

start:          di
		ld	a,50h
		out	(02h),a
		ld	a,129
		out	(speaker),a
		
		ld      sp,8000h                ;Stack a program elott

                ld      a,r                     ;Veletlenszam generator
                ld      (random+1),a            ;inicializalasa

		call	disp.off
		call	intro

		ld	a,50h
		out	(02h),a

		ld	a,129
		out	(speaker),a
		
		ld	a,21
		out	(04h),a
		ld	a,29
		out	(05h),a
		
		ld	a,81h
		out	(speaker),a
		ld	a,1fh
		out	(05h),a
		ld	a,0feh
		out	(04h),a
		
		
                call    disp.off                ;Micolor disp. feketere
                                                ;igy nem latszik a rajzolas

;Sprite-ok X eltolasahoz le kell generalni a kepeket, igy gyorsabb a raj-
;zolasuk. A micolor 1 byte-on 4 pixelt abrazol ezert van ra szukseg.
;(Rajzolni is lehetett volna, de igy egyszerubb volt)

                ld      iy,base                 ;Bazis
                call    genspr
                ld      iy,enemy.10pts          ;10 pontos ellenseg
                call    genspr
                ld      iy,enemy.20pts          ;20 pontos ellenseg
                call    genspr
                ld      iy,enemy.40pts          ;40 pontos ellenseg
                call    genspr
                ld      iy,enemy.80pts          ;80 pontos ellenseg
                call    genspr
                ld      iy,enemy.empty          ;Kilott ellenseg (ures)
                call    genspr

		call	genchr
		
                call    clrscr                  ;Kepernyok torlese, help scr.
                call    draw.bg                 ;Hatter

                call    print.high              ;'HIGH'
                call    print.score             ;'SCORE'

                call    disp.on                 ;Palettebeallitasa, igy mar
                                                ;latszik a hatter

                ld      iy,base                 ;Eletek szamat a bazisrajza
                ld      c,0                     ;jelzi, ezt rajzolja a status
                ld      de,0010h                ;sorba (bal oldal, 10.sor)
                call    sprite

;----------------------------------------------------------------------------
; Demo inicializalasa. Game over utan ide ter vissza
;
; A demo valtozo: 0 - game, egyebkent szamlalo, hogy milyen surun kerjen
;                 uj veletlen billentyuket
;----------------------------------------------------------------------------

restart:        ld      a,100                   ;Demo mod
                ld      (demo),a

                call    game                    ;Jatek inditasa

                ld      a,(exitcode)            ;A kilepes modja?
                cp      2                       ;<Break>+<Clear>?
                jp      z,start                 ;Reset game

                call    clr.all.e               ;Ellensegek torlese
                call    clr.base                ;Bazistorlese

                ld      a,(exitcode)            ;Enter-rel lepett ki?
                dec     a
                jr      nz,restart              ;Ha nem, ujabb demo

                ;Normal jatek inditasa

                xor     a                       ;Demo mod torlese
                ld      (demo),a

		call	play.getready
		
                call    game                    ;Mehet a jatek

                ld      a,(exitcode)            ;Mivel lepett ki?
                cp      2                       ;Brk+Clr?
                jp      z,start                 ;Igen, reset game

                call    clr.all.e               ;Torli az ellensegeket
                call    clr.base                ;Torli a bazist
                jr      restart                 ;Demo modba

;----------------------------------------------------------------------------
; game - a jatek vezerlese
;----------------------------------------------------------------------------

game:           ld      a,3                     ;Kezdeti eletek szama
                call    set.lives               ;Csak a valtozot allitja be

                call    clear.score             ;Pontok nullazasa es kiirasa
                call    print.lives             ;Eletek kiirasa

                ld      a,startammo             ;Kezdeti loszerek beallitasa
                ld      (maxammo),a

		xor	a
		ld	(ammoon),a
		ld	(showbonus),a
		ld	(bonus.out),a
		
;Palya inicializalasa: ellensegek,bonuszok alaphelyzetbe.

game_next:      call    reset.game              ;Ellensegek, bazis, loszer
                                                ;Hatter megtisztitasa az
                                                ;esetleg ottmaradt loszerek-
                                                ;tol (clean)

                ld      ix,bonus.table          ;Bonuszok alaphelyzetbe:
                xor     a
                ld      (ix+16),a               ;Kovetkezo bonus (bnext)
                ld      (ix+17),24              ;Szamlaloja (bcount)
                ld      (ix+18),a               ;Pontszam eltunes szamlalo

                ld      (exitcode),a            ;Kilepesi mod torlese
                call    clr.allbonus            ;Bonuszok torlese
                call    drw.allbonus            ;Bonuszok a helyukre
                call    disp.all.e              ;Ellensegek kirajzolasa

;----------------------------------------------------------------------------
; Main loop, a jatek 1 lepese
;----------------------------------------------------------------------------

game_loop:      xor     a
                ld      (spr.drawcnt),a
                call    inkey                   ;Billentyuk beolvasasa
                call    move.base               ;Bazis mozgatasa
		call	wait
                call    disp.base               ;Bazis az uj helyere

                call    fire.base               ;Bazis lovese inditasa (ha)
                call    bfire.move              ;Bazis lovedek mozgatasa

                call    move.all                ;Ellensegek mozgatasa
                call    test.enemy              ;Ellensegek utkozeset vizsg.


                ld      a,(efire.phase)         ;Ell. lovedekek mozgatasa,
                xor     1                       ;1.5 pixel / loop
                ld      (efire.phase),a         ;Gyakorlatilag egyszer 1-et,
                inc     a                       ;egyszer 2-t lep
;                call    nz,efire.move
                call    efire.move

                call    efire.gen               ;Ell. loves generalas
                call    test.base               ;Bazis utkozik vkivel?
                call    test.bonus              ;Bazis felveszi a bonust?
                call    test.bdelay             ;Bonus pontszam torolheto?
                call    test.empty              ;Ellensegek kilove?
                call    test.ammo               ;Loszert fel lehetvenni?
                call    ammo.effect             ;Loszerfelvetel hangja
                call    timer		

                ld      ix,base.table           ;Bazis felrobban?
                ld      a,(ix+12)               ;base.firephase, robbanas
                or      a                       ; fazisa
                jp      p,game_1                ;Meg nem robbant fel teljesen

                ;A bazis teljesen felrobbant

                cp      80h                     ;Robbanas utolso fazisa?
                call    z,clr.base              ;Ha igen, torli

                ld      (ix+12),-1              ;Felrobbant allapot (firephase)

                ld      a,(ix+13)               ;Robbanas utan meg mozognak
                or      a                       ;az ellensegek. (delay)
                jr      z,game_2                ;Ez az ido lejart?
                dec     (ix+13)                 ;Ha meg nem, csokkenti

                ;Billentyuk tesztelese

game_1:         ld	a,2
		call	getkey
		and	01000000b		;<Q>

                ld      a,2                     ;Brk+Clr -> exitcode(2)
                jr      nz,game_exit

		ld	a,3
		call	getkey
		and	01000000b		;<P>
		
                call    nz,pause                 ;Igen, pause game

                ld      a,(demo)                ;Demo mod?
                or      a
                jr      z,game_loop             ;Ha nem, mehet a kov. ciklus

		ld	a,5
		call	getkey
		and	00010000b
		
                jp      z,game_loop             ;Nem, tovabb megy a demo
                ld      a,1                     ;Exitcode(1)

                ;Kilepes kerese

game_exit:      ld      (exitcode),a            ;Kilepesi kod
                ld      ix,base.table           ;Bazis torlesehez felrobbant
                ld      (ix+12),80h             ;allapotot jelez (firephase)
                ld      (ix+13),restartdelay    ;Kilepes elotti varakozas
                jp      game_loop               ;Mehet meg tovabb

                ;Kilepes engedelyezese
		
game_2:         ld      hl,fire.table           ;Van meg mozgo lovedek
                xor     a                       ;a palyan?
                ld      b,12                    ;(X,Y poziciokat vizsgalja,
game_3:         or      (hl)                    ;0,0 jelzi a lovedeknel,
                inc     hl                      ;hogy nem megy)
                djnz    game_3
                jr      nz,game_1               ;Addig nem engedelyezi a
                                                ;kilepest, amig van lovedek

                ld      a,(exitcode)            ;Mi kerte a kilepest?
                dec     a                       ;Enter?
                scf
                ret     z                       ;Igen, kilep a demobol

                dec     a                       ;Reset?
                ccf
                ret     z                       ;Igen, mehet

                dec     a                       ;Ellensegek kilove?
                jr      z,game_4                ;Igen, kovetkezo palya
                                                ;inditasa

                ;Egyebkent "csak" meghaltal

                ld      hl,lives                ;Mennyi elet maradt?
                ld      a,(hl)
                inc     hl
                or      (hl)
		push	af
		call	z,play.gameover
		pop	af
                ret     z                       ;Ha elfogyott, game over

                ;Van meg elet, ellensegek vissza a helyukre

                call    clr.all.e               ;Ellensegek torlese
                call    clr.base                ;Bazis torlese
                call    reset.table             ;Ellensegek helyukre
                call    disp.all.e              ;Kirajzolasuk
;                call    redraw.bonus            ;Az esetleg kintmaradt bonus
                jp      game_loop               ;vissza a helyere es mehet is
                                                ;tovabb a jatek

                ;Ellensegek kilove, kovetkezo palya inicializalasa

game_4:         call    clr.base                ;Bazis torlese
                ld      a,(maxammo)             ;Loszerek csokkentese
                cp      min.ammo+1              ;Lehet kevesebb?
                jp      c,game_next             ;Nem, mehet a jatek
                sub     4                       ;Kevesebb loszert ad
                ld      (maxammo),a             ;minden palyan
                jp      game_next               ;Tovabb -->

;wait:		in	a,(59h)
;		and	10h
;		jr	nz,wait
;		out	(07h),a
;		ret

wait:		ld	hl,retrace
wait1:		ld	a,(hl)
		or	a
		jr	z,wait1
		ld	(hl),0
		ret

irq:		push	af
		ld	a,(irqphase)
		or	a
		jr	nz,irq2
	
;irq az utolso sor utan, zoldre valtja a palettat
		
irq1:		ld	a,14h			;sarga
		out	(61h),a
;		ld	a,05h			;lila
;		out	(62h),a
		ld	a,14
		out	(70h),a
		ld	a,02h
		out	(71h),a
		ld	a,15
		out	(70h),a
		xor	a
		out	(71h),a
		dec	a
		ld	(irqphase),a
		ld	(retrace),a
		out	(07h),a
		pop	af
		ei
		reti

;irq a masodik sor utan, cyanra valtja a palettat
		
irq2:		ld	a,11h			;cyan
		out	(61h),a
;		ld	a,04h			;piros
;		out	(62h),a
		ld	a,14
		out	(70h),a
		ld	a,0Eh
		out	(71h),a
		ld	a,15
		out	(70h),a
		ld	a,0ffh
		out	(71h),a
		xor	a
		ld	(irqphase),a
		out	(07h),a
		pop	af
		ei
		reti

timer:		;ld	b,100
		;djnz	$
		;ld      a,(spr.drawcnt)
                ;cp      max.enemy
                ;ret     nc
                ;ld      iy,enemy.empty
                ;ld      d,14
                ;ld      e,8
                ;call    sprite
		;call	draw.bonus.timer
		ld	a,(showbonus)
		or	a
		call	nz,set.bonusscr
		ld	de,(bonus.addr)
		ld	a,(bonus.out)
		or	a
		call	nz,draw.bonus
		ret
		jr      timer

;----------------------------------------------------------------------------
; pause - pause game
;
; <CLR> felengedes -> lenyomas -> felengedes
;
;----------------------------------------------------------------------------

pause:          call    print.pause             ;'PAUSE'

pause_1:        ld	a,3
		call	getkey
		and	01000000b

;		ld      a,(keyboard+40h)        ;felengedesre var
;                and     2
                jr      nz,pause_1

                ld      b,0                     ;"Prelleges"
                djnz    $

pause_2:        ld	a,3
		call	getkey
		and	01000000b
                jr      z,pause_1

                djnz    $

pause_3:        ld	a,3
		call	getkey
		and	01000000b
		jr      nz,pause_3

                djnz    $

                jp      clr.pause               ;Felirat torlese utan mehet
                                                ;tovabb a jatek

;----------------------------------------------------------------------------
; draw.ammo - loszerek kirajzolasa D (x) E (y) poz.ba
;----------------------------------------------------------------------------

draw.ammo:      srl     d                       ;X poz. -> X mem cim
                srl     d

		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	e,d
		ld	d,80h
		add	hl,de
		
		ld	bc,128
		add	hl,bc			;y+2

		ld	(ammoaddr),hl
		
redraw.ammo:	ld	hl,(ammoaddr)
		
		ld	de,ammoimg
		ld	b,12
draw.ammo1:	ld	a,(de)
		or	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		or	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		or	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		or	(hl)
		ld	(hl),a
		inc	de
		ld	a,l
		add	a,61
		ld	l,a
		ld	a,h
		adc	a,0
		ld	h,a
		
		djnz	draw.ammo1
		ld	a,0ffh
		ld	(ammoon),a
		ret
		
clr.ammo:	srl     d                       ;X poz. -> X mem cim
                srl     d

		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	e,d
		ld	d,80h
		add	hl,de
		
		ld	bc,128
		add	hl,bc			;y+2
		
		ld	de,ammoimg
		ld	b,12
clr.ammo1:	ld	a,(de)
		cpl
		and	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		cpl
		and	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		cpl
		and	(hl)
		ld	(hl),a
		inc	de
		inc	hl
		ld	a,(de)
		cpl
		and	(hl)
		ld	(hl),a
		inc	de

		ld	a,l
		add	a,61
		ld	l,a
		ld	a,h
		adc	a,0
		ld	h,a
		
		djnz	clr.ammo1
		xor	a
		ld	(ammoon),a
		ret

		
		;--------------------------
		
                ld      de,0011110000111100b    ;Oldalso pont minta
		ld	bc,64
		add	hl,bc			;y+2
		add	hl,bc

                push    hl
		add	hl,bc
		add	hl,bc
		add	hl,bc
		add	hl,bc
		add	hl,bc

                call    draw.ammo_2             ;Baloldali pont

                inc     hl                      ;x+3
                inc     hl
                inc     hl
                call    draw.ammo_1             ;Jobb oldali pont

                pop     hl                      ;y+2 sorra all
                inc     hl                      ;x+1
                push    hl

                ld      de,0000001111000000b    ;Kozepso pont minta
                call    draw.ammo_2             ;Pont bal fele
                inc     hl                      ;x+1
                call    draw.ammo_1             ;Jobbfele
                pop     hl

		add	hl,bc			;y+12 sorra all
		add	hl,bc
		add	hl,bc
		add	hl,bc
		add	hl,bc
		
		add	hl,bc
		add	hl,bc
		add	hl,bc
		add	hl,bc
		add	hl,bc
		
                call    draw.ammo_2                      ;pont balfele
                inc     hl

                ;Ket-ket pont rajzolasa egymas ala
                ;Xor-ral kell rajzolni a lovedekek miatt

draw.ammo_1:    ld      a,(hl)
                xor     d
                ld      (hl),a
		sbc	hl,bc
                ld      a,(hl)
                xor     d
                ld      (hl),a
                ret

draw.ammo_2:    ld      a,(hl)
                xor     e
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                xor     e
                ld      (hl),a
                ret

;----------------------------------------------------------------------------
; test.ammo - loszert lehet felvenni?
;----------------------------------------------------------------------------

test.ammo:      ld      a,(ammo)                ;Loszerek mar kint vannak?
                cp      9                       ;(8-nal teszi ki)
                ret     nc                      ;Meg nem, kilep

                ld      ix,base.table           ;Bazis loszernel jar?
                ld      iy,ammo.xpos

                ld      a,(ix+0)                ;base.xpos
                sub     (iy+0)                  ;ammo.xpos

                jr      nc,test.ammo_1                   ;ABS
                neg

test.ammo_1:    cp      14                      ;2 ures pont van vizszintesen
                ret     nc                      ;loszer rajzban, ezt is fi-
                                                ;gyelembe kell venni

                ld      a,(ix+1)                ;base.ypos
                sub     (iy+1)                  ;ammo.ypos

                jr      nc,test.ammo_2                   ;ABS
                neg

test.ammo_2:    cp      11                      ;Loszer 2, bazis 3 ures pont
                ret     nc                      ;fuggolegesen

                ld      d,(iy+0)                ;Loszer torlese (Xor)
                ld      e,(iy+1)
                call    clr.ammo

                ;Loszer felvetel hang inditasa

                ld      a,14                    ;Hang beallitasa
                ld      (ammoeff),a

                ld      a,(maxammo)             ;Loszer feltoltese
                ld      (ammo),a
                ret

;----------------------------------------------------------------------------
; test.empty - osszes ellenseg kilove? ha igen, exitcode(3)
;----------------------------------------------------------------------------

test.empty:     ld      a,(exitcode)
                cp      3                       ;Mar az elobb megvolt?
                ret     z

                ld      hl,enemy.pts            ;Ellensegek vannak meg?
                xor     a                       ;enemy.pts: 0 ha kilove
                ld      b,11
test.empty_1:             or      (hl)
                inc     hl
                djnz    test.empty_1

                or      a                       ;Mind kilove?
                ret     nz                      ;Meg nem

                ld      a,3                     ;Exitcode(3)
                ld      (exitcode),a

                ld      ix,base.table
                ld      (ix+12),-1              ;firephase
                ld      (ix+13),120             ;delay - hosszabb szunet
                ret

;----------------------------------------------------------------------------
; test.bonus - bonust felveszi?
;----------------------------------------------------------------------------

test.bonus:     ld      ix,bonus.table
                ld      a,(ix+16)               ;Melyik bonus? (bnext)
                cp      4                       ;Elfogytak?
                ret     nc

                ld      a,(ix+17)               ;Kint van?
                cp      13                      ;12 loves utan teszi ki
                ret     nc

                ld      iy,base.table           ;Bazis poziciok
                ld      c,(ix+16)               ;Bonus indexeles
                ld      b,0
                add     ix,bc

                ld      a,(ix+0)                ;Bonus xpos
                sub     (iy+0)                  ;base.xpos

                jr      nc,test.bonus_1         ;ABS
                neg

test.bonus_1:   cp      16                      ;dX < 16?
                ret     nc

                ld      a,(ix+8)                ;Bonus ypos
                cp      (iy+1)                  ;Sor megegyezik?
                ret     nz

                call    bonus.effect            ;Bonus felvetel hangja
                jp      bonus.scr               ;Bonus pontszam kiirasa

;----------------------------------------------------------------------------
; test.bdelay - bonus pontszam torolheto?
;----------------------------------------------------------------------------

test.bdelay:    ld      ix,bonus.table
                ld      a,(ix+18)               ;bdelay
                or      a                       ;nincs kint?
                ret     z

                dec     a                       ;Csokkenti az idot
                ld      (ix+18),a
                ret     nz                      ;Lejart?
                jp      clr.bonusscr            ;Ha igen, torli a pontszamot

;----------------------------------------------------------------------------
; test.base - bazis utkozik valakivel?
;----------------------------------------------------------------------------

test.base:      ld      ix,base.table           ;Bazis adatok
                ld      a,(ix+12)               ;Epp felrobban?
                or      a
                ret     nz

                ld      iy,enemy.table          ;Ellenseg adatok
                ld      b,11                    ;11 ellenseg van
test.base_1:    ld      a,(iy+44)               ;Kilott ellenseg?
                or      a
                jr      z,test.base_4                    ;Igen,->

                cp      8                       ;Felrobbano ellenseg?
                jr      nc,test.base_4                   ;Igen, ->

                ld      a,(iy+0)                ;enemy.xpos
                sub     (ix+0)                  ;base.xpos

                jr      nc,test.base_2                   ;ABS
                neg

test.base_2:    cp      16                      ;<16?
                jr      nc,test.base_4

                ld      a,(iy+11)               ;enemy.ypos
                sub     (ix+1)                  ;base.ypos

                jr      nc,test.base_3                   ;ABS
                neg

test.base_3:    cp      11
                jr      nc,test.base_4

                ld      (ix+12),8               ;Bazis robbanas inditasa
                ld      (ix+13),restartdelay    ;Felrobbanas utani kivaras
                call    dec.lives               ;Eletek csokkentese
                jr      snd.explosion           ;Robbanas hangja

test.base_4:    inc     iy                      ;Kovellensegvizsgalata
                djnz    test.base_1
                ret

play.getready:	ld	hl,snd.getready
		ld	de,snd.getready.end-snd.getready
		jr	snd.expl1
		
play.gameover:	ld	hl,snd.gameover
		ld	de,snd.gameover.end-snd.gameover
		jr	snd.expl1
		
snd.explosion:  call	rnd
		and	1
		jr	z,snd.exp.ohno
		ld	hl,snd.au
		ld	de,snd.au.end-snd.au
		jr	snd.expl1
		
snd.exp.ohno:	ld	hl,snd.ohno
		ld	de,snd.ohno.end-snd.ohno
		
snd.expl1:	ld	c,8
snd.expl2:	ld	a,(hl)
		and	1
		jr	z,snd.expl3
		ld	a,81h+1ch
		jr	nz,snd.expl4
snd.expl3:	ld	a,81h
snd.expl4:	out	(speaker),a
		ld	b,10
		djnz	$
		rrc	(hl)
		dec	c
		jr	nz,snd.expl5
		inc	hl
		dec	de
		ld	a,d
		or	e
		jp	nz,snd.expl1
		ld	a,81h
		out	(speaker),a
		ret
		
snd.expl5:	call	snd.expl6
		ld	a,a
		jr	snd.expl2
snd.expl6:	ret
		

snd.explosion1:  ld      b,8                     ;Robbanas hangja
snd.explosion_1:ld      c,80
                call    snd.noise
                djnz    snd.explosion_1
                ret

;----------------------------------------------------------------------------
; efire.gen - ellenseg loves generalas
;----------------------------------------------------------------------------

efire.gen:      ld      a,(base.firephase)      ;Bazis felrobban?
                or      a                       ;Ha igen, nem lonek
                ret     nz

                ld      ix,enemy.table          ;Ellenseg adatok
                ld      b,11

efire.gen_1:    push	bc
		push	ix
		ld      a,(ix+44)               ;enemy.pts
                or      a                       ;Kilove?
                jr      z,efire.gen_2           ;Igen, next

                cp      8                       ;Epp felrobban?
                jr      nc,efire.gen_2          ;Igen, next

                call    rnd                     ;Generaljon lovest?
                cp      10h
                jr      nc,efire.gen_2
                call    rnd
                cp      10h
                call    c,efire.gen_3           ;Igen, -->

efire.gen_2:    pop	ix
		pop	bc
		inc     ix                      ;Kov. ellenseg
                djnz    efire.gen_1
                ret

                ;(ix) ellensegnek loves generalasa

efire.gen_3:    ld      c,6                     ;Van meg hely lovesnek?
                ld      iy,fire.table           ;Ellenseg lovesadatok
efire.gen_4:    ld      a,(iy+0)                ;xpos es ypos = 0?
                or      (iy+6)
                jr      z,efire.gen_5           ;igen, szabad hely
                inc     iy
                dec     c
                jr      nz,efire.gen_4

                ;nins hely lovesnek (max 6 lehet egyszerre)

                pop     bc                      ;torli a tovabbi lovesgenera-
                pop     bc                      ;torli a tovabbi lovesgenera-
                pop     bc                      ;torli a tovabbi lovesgenera-
                ret                             ;lasokat es kilep

efire.gen_5:    ld      d,(ix+0)                ;enemy.xpos
                ld      e,(ix+11)               ;enemy.ypos
                ld      (iy+12),0               ;fire.xd
                ld      (iy+18),0               ;fire.yd

                ld      a,d                     ;ellenseg bal szelen
                cp      008h
                jr      z,efire.gen_10

                cp      0E8h                    ;jobb szelen?
                jr      z,efire.gen_11

                ld      a,e                     ;felso sorban?
                cp      028h
                jr      z,efire.gen_12

                ;ha nem, akkor kint van mozgasban

                ld      a,(ix+22)               ;enemy.xdir
                or      a
                jr      z,efire.gen_6           ;fuggolegesen mozog

                dec     a
                jr      z,efire.gen_22          ;jobbra mozog
                jr      efire.gen_21            ;balra mozog

efire.gen_6:    ld      a,(ix+33)
                dec     a
                jr      z,efire.gen_24          ;lefele mozog
                jr      efire.gen_23            ;felfele mozog

                ;bal szelen van

efire.gen_10:   ld      a,e                     ;kint van a sorban?
                and     1Fh
                xor     8
                ret     nz
                jr      efire.gen_22            ;jobbra lo

                ;jobb szelen van

efire.gen_11:   ld      a,e
                and     1Fh
                xor     8
                ret     nz
		ld	a,e
		cp	68h
		jr	z,efire.gen_21
		cp	0a8h
		jr	z,efire.gen_21
		nop
                jr      efire.gen_21            ;balra lo

                ;fent van

efire.gen_12:   ld      a,d
                and     1Fh
                xor     8
                ret     nz
                jr      efire.gen_24            ;lefelelo

                ;loves inditasa balra

efire.gen_21:   ld      a,d                     ;x-4 -re (4 szeles a lovedek)
                sub     4
                ld      (iy+0),a                ;fire.xpos
                ld      a,e                     ;y+7 -re (sor kozepere)
                add     a,7
                ld      (iy+6),a                ;fire.ypos
                dec     (iy+12)                 ;fire.xd, balra mozgas
                jp      efire.set

                ;jobbra

efire.gen_22:   ld      a,d                     ;x+16-ra (16 szeles az ell.)
                add     a,16
                ld      (iy+0),a                ;fire.xpos
                ld      a,e
                add     a,7                     ;sor kozepere
                ld      (iy+6),a                ;fire.xpos
                inc     (iy+12)                 ;fire.xd
                jp      efire.set

                ;fel

efire.gen_23:   ld      a,d                     ;oszlop kozepere
                add     a,7
                ld      (iy+0),a                ;fire.xpos
                ld      a,e                     ;y-4 (4 magas a lovedek)
                sub     4
                ld      (iy+6),a                ;fire.ypos
                dec     (iy+18)                 ;fire.yd
                jp      efire.set

                ;lefele

efire.gen_24:   ld      a,d                     ;oszlop kozepere
                add     a,7
                ld      (iy+0),a                ;fire.xpos
                ld      a,e                     ;y+16
                add     a,16
                ld      (iy+6),a                ;fire.ypos
                inc     (iy+18)                 ;fire.yd
                jp      efire.set

;----------------------------------------------------------------------------
; test.efire - ellenseg loves talalt?
;----------------------------------------------------------------------------

test.efire:     ld      a,(base.firephase)      ;mar eltalaltak?
                or      a
                ret     nz

                ld      ix,base.table           ;bazis adatok

                ld      a,(ix+0)                ;base.xpos
                add     a,6                     ;lovedek-bazis tav.offset
                sub     (iy+0)                  ;fire.xpos

                jr      nc,test.efire_1                   ;ABS
                neg

test.efire_1:             cp      9                       ;oszlop ok?
                ret     nc

                ld      a,(ix+1)                ;base+yp
                add     a,6                     ;lovedek-bazis offset
                sub     (iy+6)                  ;fire.ypos

                jr      nc,test.efire_2                   ;ABS
                neg

test.efire_2:             cp      5                       ;talalt?
                ret     nc

                ld      (iy+0),0                ;lovedek torlese
                ld      (iy+6),0

                ld      (ix+12),8               ;Robbanas inditasa
                ld      (ix+13),restartdelay    ;Kivaras
                call    snd.explosion           ;Robbanas hangja
                call    dec.lives
                scf
                ret

;----------------------------------------------------------------------------
; test.bfire - bazis loves talalt? (iy = base.table)
;----------------------------------------------------------------------------

test.bfire:     ld      ix,enemy.table          ;Ellenseg adatok
                ld      b,11

test.bfire_1:             ld      a,(ix+44)               ;enemy.pts
                or      a                       ;Kilove?
                jr      z,test.bfire_6                    ;Igen, next
                cp      8                       ;Most robban?
                jr      nc,test.bfire_6                   ;Igen, next

                ld      a,(ix+0)                ;enemy.xpos
                add     a,6                     ;ellenseg-lovedek offset
                sub     (iy+4)                  ;base.firexp

                jr      nc,test.bfire_2                   ;ABS
                neg

test.bfire_2:             cp      10                      ;Talalt?
                jr      nc,test.bfire_6                   ;Biztos nem, next

                ld      a,(ix+11)               ;enemy.ypos
                add     a,6                     ;ellenseg-lovedek offset
                sub     (iy+5)                  ;base.fireypos

                jr      nc,test.bfire_3                   ;ABS
                neg

test.bfire_3:             cp      9                       ;Talalt?
                jr      nc,test.bfire_6                   ;Nem, next

                ;Bazis lovese talalt

                ld      a,(ix+44)               ;enemy.pts
                ld      b,a
                add     a,10h                   ;Robbanas inditasa
                ld      (ix+44),a

                ld      (iy+4),0                ;Bazis loves torlese
                ld      (iy+5),0

                ld      a,1                     ;Pontozas
test.bfire_4:   dec     b
                jr      z,test.bfire_5
                sla     a
                jr      test.bfire_4

test.bfire_5:   call    addscore                ;Pontszam novelese
                jr      snd.enemyexp            ;Talalat hangja

test.bfire_6:   inc     ix                      ;Kovetkezo ellenseg
                djnz    test.bfire_1
                or      a
                ret

snd.enemyexp:   ld      bc,0540h                ;Talalat hangja
snd.enemyexp_7: call    snd.noise
                srl     c
                djnz    snd.enemyexp_7

                scf
                ret

;----------------------------------------------------------------------------
; addscore - pontozas
;----------------------------------------------------------------------------

addscore:       ex      af,af'                  ;Pont mentese
                ld      a,(demo)                ;Demo mod?
                or      a
                ret     nz                      ;Igen, nics pontozas

                ld      a,(score+1)             ;Tizezres jegy mentese
                ex      af,af'                  ;es pontszam vissza

                ld      hl,score+4              ;Oszeadas(BCD)
                ld      b,5                     ;5 szamjegy
addscore_1:     add     a,(hl)
                daa
                ld      c,a
                and     15
                ld      (hl),a
                ld      a,c
                srl     a
                srl     a
                srl     a
                srl     a
                dec     hl
                djnz    addscore_1

                call    print.score             ;Pontszam kiirasa

                ld      a,(score+1)             ;Uj tizezres jegy?
                ld      b,a
                ex      af,af'                  ;Eredeti elo
                cp      b                       ;Valtozott?
                call    nz,inc.lives            ;Ha igen, ad egy eletet

                ld      b,5                     ;score > high?
                ld      de,score
                ld      hl,highscore
addscore_2:             ld      a,(de)
                sub     (hl)
                jr      z,addscore_3
                ret     c

                ;score masolasa high-be

                ld      hl,score
                ld      de,highscore
                ld      bc,5
                ldir
                jp      print.high              ;High-Score kiirasa

addscore_3:             inc     de
                inc     hl
                djnz    addscore_2
                ret


;----------------------------------------------------------------------------
; test.enemy - ellensegek utkozeset vizsgalja
;----------------------------------------------------------------------------

test.enemy:     ld      iy,enemy.table          ;Ellenseg adatok

                ld      c,10                    ;+10 ellenseg van
test.enemy_1:             ld      a,(iy+22)               ;Mozog?
                or      (iy+33)
                jr      z,test.enemy_4                    ;Nem, nem is utkozhet

                ld      a,(iy+44)               ;Kilove?
                or      a
                jr      z,test.enemy_4                    ;Igen, -->
                cp      8
                jr      nc,test.enemy_4

                ld      b,c
                push    iy
                pop     ix                      ;Kovetkezo ellenseg adatai
                inc     ix

test.enemy_2:             ld      a,(ix+44)               ;Kilove?
                or      a
                jr      z,test.enemy_3                    ;Igen, next
                cp      8
                jr      nc,test.enemy_3

                ld      a,(ix+22)               ;Mozog?
                or      (ix+33)
                jr      z,test.enemy_3                    ;Nem, next

                ld      a,(ix+0)                ;x poziciok osszehasonlitasa
                sub     (iy+0)
                ld      d,15                    ;15-nel kisebb a tavolsag?
                call    test.enemy_11
                jr      nc,test.enemy_3                   ;nem, next

                ld      a,(ix+11)               ;y poziciok osszehasonlitasa
                sub     (iy+11)
                ld      d,13                    ;ures sorokat kivonja
                call    test.enemy_11
                jr      nc,test.enemy_3

                ;osszeutkoztek

                ld      a,(ix+44)               ;Mindket ellensegnel
                add     a,10h                   ;robbanas inditasa
                ld      (ix+44),a

                ld      a,(iy+44)
                add     a,10h
                ld      (iy+44),a

                call    snd.enemyexp            ;Utkozes hangja

test.enemy_3:   inc     ix
                djnz    test.enemy_2

test.enemy_4:   inc     iy
                dec     c
                jr      nz,test.enemy_1
                ret

test.enemy_11:  jr      nc,test.enemy_12
                neg
test.enemy_12:  cp      d
                ret


;----------------------------------------------------------------------------
; basefire - bazis robbanas
;----------------------------------------------------------------------------

basefire:       ret     m                       ;Mar felrobbant?
                and     0F0h                    ;Robbanas fazisa
                ld      c,a
		
                ld      a,(base.ypos)           ;disp.cim szamolasa
		ld	l,a
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl

                ld      a,(base.xpos)
		ld	e,a
                srl     e
                srl     e
		ld	d,80h
                add	hl,de
                ex	de,hl
		ld	l,c
		
                call    drawfire                ;Tuz rajzolasa

                ld      a,(base.firephase)      ;Kovetkezo fazis
                add     a,8
                ld      (base.firephase),a
                ret

;----------------------------------------------------------------------------
; firegen - ellenseg robbanasa
;----------------------------------------------------------------------------

firegen:        sub     10h                     ;Robbanas fazisa
                or      a
                jp      p,firegen_0                    ;Robbanas vege?

                ld      a,(iy+44)               ;enemy.pts
                push    af
                ld      (iy+44),0               ;Ellenseg torlese

                call    disp.enemy              ;Ures ellenseg kirajzolasa

                pop     af
                and     7                       ;Ellenseg tipusa
                inc     a                       ;Kovetkezo tipus
                cp      5                       ;Nins tobb?
                ret     nc

                ld      (iy+44),a               ;Beallitas
                push    iy
                pop     ix
                ld      de,default.table-enemy.table
                add     ix,de                   ;Default adatok

                ld      d,(ix+0)                ;Ellenseg pozicio
                ld      e,(ix+11)
                ld      (iy+0),d
                ld      (iy+11),e
                ld      (iy+22),0               ;Mozgas nincs
                ld      (iy+33),0
                jp      disp.enemy              ;Uj ellenseg kirajzolasa

firegen_0:      push    iy                      ;Robbanas rajzolasa
		ld	e,a
		ld	l,(iy+11)
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
                ld      a,(iy+0)
                srl     a
                srl     a
		add	a,l
		ld	l,a
		ld	a,h
		adc	a,80h
		ld	h,a
		ex	de,hl

                call    drawfire

                pop     iy                      ;Robbanas kov. fazisa
                ld      a,(iy+44)
                add     a,8
                ld      (iy+44),a
                ret

;----------------------------------------------------------------------------
; drawfire - robbanas rajzolasa
;----------------------------------------------------------------------------

drawfire:       ld      a,l                     ;Fazis?
                ld      h,0                     ;Robbanas rajz cime
                add     hl,hl                   ;(*64)
                add     hl,hl
                ld      bc,fire
                add     hl,bc

                ld      b,16                    ;16 disp.sor
                ex      de,hl
                push    de                      ;HL disp.cim, IY rajz cime
                pop     iy

                cp      40h
                jr      c,drawfire_2            ;tuz

                ;Elhalvanyodik

drawfire_1:     ld      a,(iy+2)
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                and     (hl)
                ld      (hl),a
                dec     hl
                dec     hl
                dec     hl
		ld	de,64
		add	hl,de
                inc     iy
                inc     iy
                inc     iy
                inc     iy
                djnz    drawfire_1
                ret

                ;Tuz rajzolasa

drawfire_2:     ld      a,(iy+2)                ;"10" bitek beirasa
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                or     (hl)
                ld      (hl),a
                dec     hl
                dec     hl
                dec     hl
		ld	de,64
		add	hl,de
                inc     iy
                inc     iy
                inc     iy
                inc     iy
                djnz    drawfire_2
                ret

;----------------------------------------------------------------------------
; disp.base - bazis kirajzolasa a poziciojaba
; clr.base  - torlese
;----------------------------------------------------------------------------

clr.base:       ld      iy,enemy.empty          ;Ures sprite
		xor	a
		ld	(showbase),a
                jr      disp.base_1

disp.base:      ld      a,(exitcode)            ;Ellensegek kilove?
                cp      3
                jr      z,disp.base_0

                ld      a,(base.firephase)      ;Bazisrobban?
                or      a
                jp      nz,basefire             ;Ha igen, robbanast rajzol

disp.base_0:    ld      iy,base                 ;Bazis rajza
		ld	a,0ffh
		ld	(showbase),a
disp.base_1:    ld      ix,base.table           ;Display cim szamolasa
                ld      a,(ix+0)
                and     3
                ld      c,a                     ;X offset
                ld      d,(ix+0)
                srl     d
                srl     d
                ld      e,(ix+1)
                jp      sprite                  ;Disp.re

;----------------------------------------------------------------------------
; disp.all.e - osszes ellenseg kirajzolasa
; clr.all.e  - osszes ellenseg torlese
;----------------------------------------------------------------------------

disp.all.e:     ld      iy,enemy.table          ;Ellenseg adatok
                ld      a,11                    ;11 ellenseg van
disp.all.e_1:             ex      af,af'
                call    disp.enemy
                inc     iy
                ex      af,af'
                dec     a
                jr      nz,disp.all.e_1
                ret

clr.all.e:      ld      iy,enemy.table
                ld      a,11
clr.all.e_1:             ex      af,af'
                call    clr.enemy
                inc     iy
                ex      af,af'
                dec     a
                jr      nz,clr.all.e_1
                ret

;----------------------------------------------------------------------------
; disp.enemy - IY ellenseg kirajzolasa
; clr.enemy  -             torlese
;----------------------------------------------------------------------------

clr.enemy:      ld      e,0                     ;Uressprite
                jr      disp.enemy_1

disp.enemy:     ld      e,(iy+44)               ;Enemy.pts

disp.enemy_1:             push    iy
                ld      ix,enemy.sprite         ;Sprite cimek
                ld      d,0
                sla     e
                add     ix,de                   ;Cim offset

                ld      e,(ix+0)                ;Sprite cime elo
                ld      d,(ix+1)
                push    de

                ld      d,(iy+0)                ;enemy.xpos
                ld      e,(iy+11)               ;enemy.ypos
                ld      a,d                     ;disp.cim szamolasa
                srl     d
                srl     d
                and     3
                ld      c,a                     ;x offset
                pop     iy
                call    sprite                  ;Rajzolas
                pop     iy
                ret

;----------------------------------------------------------------------------
; move.all - ellensegek mozgatasa
;----------------------------------------------------------------------------

move.all:       call    count.enemy             ;Ellensegek osszeszamolasa
                ld      iy,enemy.table          ;Ellenseg adatok
                ld      b,11                    ;11 ellenseg van

move.all_1:             push    bc
                ld      a,(iy+44)               ;enemy.pts
                cp      10h
                jr      nc,move.all_3                   ;robbanas

                or      a                       ;Kilove?
                jr      z,move.all_2

                ld      a,(iy+22)               ;enemy.xdir
                or      (iy+33)                 ;enemy.ydir
                push    af
                call    move.enemy              ;Mozgatas v. mozgas generalas
                pop     af
                call    nz,disp.enemy           ;Mozog, uj helyere kirajzolja

move.all_2:             inc     iy                      ;Kov. ellenseg
                pop     bc
                djnz    move.all_1
                ret

move.all_3:             and     0F0h                    ;Csak a robbanas fazisa marad
                push    bc
                call    firegen                 ;"Robbantas"
                pop     bc
                jr      move.all_2

;Ellensegek es a mozgo ellensegek osszeszamolasa

count.enemy:    ld      ix,enemy.table          ;Ellenseg adatok
                ld      b,11                    ;11 ellenseg
                ld      de,0                    ;Szamlalok
count.enemy_1:             ld      a,(ix+44)               ;enemy.pts
                or      a
                jr      z,count.enemy_2                    ;Kilove? Ha igen, -->

                inc     e                       ;+1 ellenseg

                ld      a,(ix+22)               ;enemy.xdir
                or      (ix+33)                 ;enemy.ydir
                jr      z,count.enemy_2                    ;Mozog?

                inc     d                       ;+1 mozgo ellenseg

count.enemy_2:             inc     ix                      ;Next
                djnz    count.enemy_1
                ld      (enemy.count),de        ;Save
                ret

enemy.count:    dw      0

;----------------------------------------------------------------------------
; move.enemy - (IY) ellenseg mozgatasa
;----------------------------------------------------------------------------
;+00 - xpos  +22 xdir +44 phase (0 off)
;+11 - ypos  +33 ydir

move.enemy:     ld      d,(iy+22)               ;enemy.xdir
                ld      e,(iy+33)               ;enemy.ydir

                ld      a,d                     ;Mozgas iranya?
                or      a
                jr      nz,move.enemy_20                  ;vizszintes

                ld      a,e
                or      a
                jp      z,move.gen              ;Nem mozog, general neki mozgast

;Megjegyzes a kovetkezo reszhez: nincs ellenorizve, hogy mozgatas utan az
;ellenseg a jatekterben maradt-e, azert mert nem kell. Ugyanis a jatekter
;szelen is keresztezodeshez er es akkor uj iranyt ker neki. Az irany pedig
;minden esetben a bazis fele fog mutatni ami a jatekterben van.

                ;fuggoleges mozgatas

                ld      a,(iy+11)               ;enemy.ypos
                add     a,e                     ;+enemy.ydir
                ld      (iy+11),a               ;Uj Ypos

                call    outofscr                ;A jatekteren kivul van?
                ld      a,(iy+11)               ;Get Ypos
                jr      c,move.enemy_12                   ;Igen, -->

move.enemy_11:            and     1Fh                     ;Keresztezodesben van?
                xor     8
                jp      z,move.gen              ;Igen, uj iranyt ker neki
                ret

move.enemy_12:            cp      48h                     ;Fent van?
                jr      c,move.enemy_11                   ;Igen. (mivel fuggolegesen
                                                ;mozog, csak lefele johet)

                and     0Fh                     ;Oldalt van kint. Csak 2
                xor     8                       ;poz. kozott mozoghat.
                ret     nz                      ;Elerte vmelyiket?

                ld      (iy+33),0               ;Igen, megallitja
                jp      move.gen                ;Uj mozgast ker

;vizszintes mozgatas

move.enemy_20:            ld      a,(iy+0)                ;enemy.ypos
                add     a,d                     ;+enemy.xdir
                ld      (iy+0),a                ;save

                call    outofscr                ;Jatekteren kivul?
                jr      c,move.enemy_22                   ;Igen, -->

                ld      a,(iy+0)                ;enemy.xpos

move.enemy_21:            and     1Fh                     ;Keresztezodesben van?
                xor     8
                jp      z,move.gen              ;Igen, uj iranyt ker
                ret

move.enemy_22:            ld      a,(iy+11)               ;enemy.ypos
                cp      28h                     ;Felso sorban mozog?
                ld      a,(iy+0)                ;Nem, akkor oldalrol jon
                jr      nz,move.enemy_21                  ;be, mehet tovabb

                and     0Fh                     ;Felso sorban is csak 2 poz.
                xor     8                       ;lehetseges. Elerte vmelyiket?
                ret     nz
                ld      (iy+22),0               ;Igen, megallitja es uj
                jp      move.gen                ;iranyt ker neki

;----------------------------------------------------------------------------
; outofscr - CY = 1, ha a jatekteren kivul van az IY ellenseg
;----------------------------------------------------------------------------

outofscr:       ld      a,(iy+0)                ;enemy.xpos
                cp      28h
                ret     c                       ;Bal oldalt kivul?
                cp      0C9h
                ccf
                ret     c                       ;Jobb oldalt kivul?

                ld      a,(iy+11)               ;enemy.ypos
                cp      48h                     ;Fent van kivul?
                ret

;----------------------------------------------------------------------------
; move.gen - ellenseg mozgasgeneralas
;
; Ha az ellenseg kint van a jatekteren, akkor keresztezodeshez erve minden-
; kepp uj iranyt kap ami a bazis fele mutat. Ha a keretben van, akkor velet-
; lenszeruen lesz elinditva. Ha 6-nal kevesebb ellenseg van, mindet elinditja.
;
;----------------------------------------------------------------------------

move.gen:       ld      a,(iy+22)               ;enemy.xdir
                or      (iy+33)                 ;enemy.ydir
                jr      nz,move.gen_1                   ;mozog, tehat kint van

                ;keretben van

                ld      de,(enemy.count)        ;D mozgo ellensegek szama,
                                                ;E ellensegek szama
                ld      a,e                     ;6-nal kevesebb ellenseg van?
                cp      6
                push    af                      ;(AF' <- status)
                ex      af,af'
                pop     af
                jr      c,move.gen_1                    ;Igen, elinditja

                ld      a,d                     ;Mennyi mozgo van?
                cp      max.enemy               ;Max mozgathato?
                ret     nc                      ;Igen, nem indit ujat

                call    rnd
                cp      5                       ;milyen gyakran generaljon
                ret     nc

                call    rnd                     ;Minel tobb loves lett leadva
                ld      d,a                     ;annal gyakrabban inditja
                ld      a,(firecount)           ;oket
                add     a,20
                cp      d
                ret     c

                ;Ellenseg inditasa

move.gen_1:             ld      (iy+22),0               ;Torli az eddigi mozgasiranyokat
                ld      (iy+33),0

                call    outofscr                ;Keretben van?
                jr      nc,move.gen_7                   ;Nem, bazis fele ->

                ld      a,(iy+11)               ;enemy.ypos
                cp      28h                     ;Felso sorban van?
                jr      nz,move.gen_4                   ;Nem, ->

                ;felso sorban van

                ld      a,(iy+0)                ;enemy.xpos
                and     1Fh                     ;El van bujva?
                xor     18h
                jr      nz,move.gen_2                   ;Nem, irany kerese

                ld      (iy+22),-1              ;Egzebkent csak balra mehet
                ret

                ;Felso sorban van, kimenjen v. vissza elbujni?

move.gen_2:             ex      af,af'                  ;Mindnek mozognia kell?
                jr      c,move.gen_3                    ;Igen, kiengedi

                ld      a,(firecount)           ;A lovesek szamatol fuggoen
                add     a,90h                   ;egyre gyakrabban fogja
                ld      e,a                     ;kikuldeni
                call    rnd
                cp      e
                jr      c,move.gen_3                    ;Menjen ki!

                ld      (iy+22),1               ;Visszamegy elbujni
                ret                             ;(enemy.xdir)

move.gen_3:             ld      (iy+33),1               ;Kifele megy (enemy.ydir)
                ret

                ;Oldalt van kint

move.gen_4:             ld      a,(iy+11)               ;enemy.ypos
                and     1Fh                     ;El van bujva?
                xor     18h
                jr      nz,move.gen_5                   ;Nem, iranyt ker

                ld      (iy+33),-1              ;Egyebkent csak felfele mehet
                ret                             ;enemy.ydir)

move.gen_5:             ex      af,af'                  ;Mindnek mozogni kell?
                jr      c,move.gen_6                    ;Igen, kiengedi

                ld      a,(firecount)           ;Irany eldontese
                add     a,90h
                ld      e,a
                call    rnd
                cp      e
                jr      c,move.gen_6

                ld      (iy+33),1               ;Visszamegy elbujni
                ret

move.gen_6:             ld      (iy+22),1               ;Bal v. jobbszelrol kell
                ld      a,(iy+0)                ;kiengedni, attol fugg az
                cp      28h                     ;x irany
                ret     c
                ld      (iy+22),-1
                ret

                ;Jatekterben van, bazis fele kell mozgatni

move.gen_7:             ld      a,(base.xpos)           ;Egy oszlopban vannak?
                cp      (iy+0)
                jr      nz,move.gen_9                   ;Nem, -->

move.gen_8:             ld      a,(base.ypos)           ;Egy oszlopban vannak, a
                cp      (iy+11)                 ;bazis fele veszi az iranyt

                ld      (iy+33),1
                ret     nc
                ld      (iy+33),-1
                ret

move.gen_9:             ld      a,(base.ypos)           ;Egy sorban vannak?
                cp      (iy+11)
                jr      nz,move.gen_11                  ;Nem, veletlenszeruen fog
                                                ;vizsz. v. fugg.-en kozeliteni

move.gen_10:            ld      a,(base.xpos)           ;Egy sorban vannak, a bazis
                cp      (iy+0)                  ;fele fog menni
                ld      (iy+22),1
                ret     nc
                ld      (iy+22),-1
                ret

move.gen_11:            call    rnd                     ;Merre menjen? 1:1
                rlca
                jr      c,move.gen_8
                jr      move.gen_10

;----------------------------------------------------------------------------
; efire.move - ellenseg loves mozgatasa
;----------------------------------------------------------------------------

efire.move:     ld      iy,fire.table           ;Lovedek adatok
                ld      b,6                     ;Max 6 lovedek lehet kint

efire.move_1:   push    bc
                call    efire.move_2            ;Lovedek mozgatasa
                pop     bc
                inc     iy
                djnz    efire.move_1
                ret

                ;Egy lovedek mozgatasa

efire.move_2:   ld      a,(iy+0)                ;firexp
                or      (iy+6)                  ;fireyp
                ret     z                       ;Nincs loves?

                call    efire.clr               ;Torli az elozo lovedeket
                ld      a,(iy+12)               ;firexd - lovedek iranya?
                or      a
                jr      z,efire.move_3          ;Fuggoleges, ->

                add     a,(iy+0)                ;Vizszintesen mozgatja
                ld      (iy+0),a

                cp      008h                    ;Kiment a keprol?
                jr      c,efire.move_4          ;Ha igen, torli
                cp      0F8h
                jr      nc,efire.move_4

                call    test.efire              ;Talalt?
                ret     c                       ;Igen, torolve
                jp      efire.set               ;Uj helyere kirajzolja

                ;Fuggolegesen mozog

efire.move_3:   ld      a,(iy+18)               ;fireyd
                add     a,(iy+6)
                ld      (iy+6),a                ;Uj poz.

                cp      028h                    ;Kiment a keprol?
                jr      c,efire.move_4
                cp      0E8h
                jr      nc,efire.move_4

                call    test.efire
                ret     c
                jp      efire.set

efire.move_4:   ld      (iy+0),0                ;Kiment, torli
                ld      (iy+6),0                ;firexp, fireyp <- 0
                ret

;----------------------------------------------------------------------------
; bfire.move - bazis loves mozgatasa
;----------------------------------------------------------------------------

bfire.move:     ld      iy,base.table           ;Bazis adatok
                ld      a,(iy+4)                ;base.firexp
                or      (iy+5)                  ;base.fireyp
                ret     z                       ;Nincs lovedek

                call    bfire.clr               ;Torli az elozo helyrol

                ld      a,(iy+10)               ;base.firexd
                or      a
                jr      z,bfire.move_1          ;Fuggoleges loves, ->

                add     a,(iy+4)                ;Uj poz.
                ld      (iy+4),a

                cp      008h                    ;Kiment a keprol?
                jr      c,bfire.move_2
                cp      0F8h
                jr      nc,bfire.move_2         ;Ha igen, torli

                call    test.bfire              ;Lovedek talalt?
                ret     c                       ;Igen, torlove
                jr      bfire.set               ;Egyebkent uj helyere ki

                ;Fuggoleges loves

bfire.move_1:   ld      a,(iy+5)                ;base.fireyp
                add     a,(iy+11)               ;+base.fireyd
                ld      (iy+5),a                ;save

                cp      028h                    ;kiment a keprol?
                jr      c,bfire.move_2
                cp      0E8h
                jr      nc,bfire.move_2

                call    test.bfire
                ret     c
                jr      bfire.set

bfire.move_2:   ld      (iy+4),0                ;Lovedek torlese
                ld      (iy+5),0
                ret

                ;Bazis lovedek kirajzolasa

bfire.clr:	ld	c,0ffh
		jr	bfire.xor
		
bfire.set:	ld	c,0
		
bfire.xor:      ld      (iy+6),0                ;firekeys

                ld      e,(iy+4)                ;Lovedek X poz.
                ld      a,e                     ;-> disp.cim
                srl     e
                srl     e
                ld      l,(iy+5)                ;Lovedek Y poz.
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	d,80h
		add	hl,de

                and     3                       ;X offset
                ld      b,a
                ld      a,(iy+10)               ;Lovedek iranya
                or      a
                ld      de,0001000110001000b    ;Feher lovedek
                jr      z,bfire.xor_3           ;fuggoleges loves

                ld      e,11111111b             ;Feher lovedek

                ;Vizszintes lovedek

bfire.xor_0:    push	ix
		push	iy
		
		push	hl
		pop	iy
		
		push	bc
		ld	c,b
		ld	b,0
		ld	ix,hfirel
		add	ix,bc
		pop	bc
		
		ld	a,c
		or	a
		jr	nz,bfire.xor_1
		
		ld	a,(ix+0)
		and	e
		or	(iy+0)
		ld	(iy+0),a
		
		ld	a,(ix+0)
		and	e
		or	(iy+64)
		ld	(iy+64),a
		
		ld	a,(ix+4)
		and	e
		or 	(iy+1)
		ld	(iy+1),a
		
		ld	a,(ix+4)
		and	e
		or 	(iy+65)
		ld	(iy+65),a

		pop	iy
		pop	ix
		ret

bfire.xor_1:	ld	a,(ix+0)
		cpl
		and	e
		and	(iy+0)
		ld	(iy+0),a
		
		ld	a,(ix+0)
		cpl
		and	e
		and	(iy+64)
		ld	(iy+64),a
		
		ld	a,(ix+4)
		cpl
		and	e
		and	(iy+1)
		ld	(iy+1),a
		
		ld	a,(ix+4)
		cpl
		and	e
		and	(iy+65)
		ld	(iy+65),a

		pop	iy
		pop	ix
		ret

                ;Fuggoleges lovedek

bfire.xor_3:    ld	a,c
		or	a
		ld	bc,64
		jr	nz,bfire.clr_3
		push	hl
		call	bfire.xor_4
		pop	hl
		inc	hl
		ld	d,e
		
bfire.xor_4:	ld      a,(hl)                  ;4 pontja egymas ala
                or      d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                or      d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                or      d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                or      d
                ld      (hl),a
                ret

bfire.clr_3:	push	hl
		call	bfire.clr_4
		pop	hl
		inc	hl
		ld	d,e
		
bfire.clr_4:	ld	a,d
		cpl
		ld	d,a
		ld      a,(hl)                  ;4 pontja egymas ala
                and     d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                and     d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                and     d
                ld      (hl),a
                add	hl,bc
                ld      a,(hl)
                and     d
                ld      (hl),a
                ret

                ;Ellenseg lovedekenek kirajzolasa

efire.clr:	ld	c,0ffh
		jr	efire.xor
		
efire.set:	ld	c,0
		
efire.xor:      ld      e,(iy+0)                ;Lovedek X poz.
                ld      a,e                     ;-> disp.cim
                srl     e
                srl     e
                ld      l,(iy+6)                ;Lovedek Y poz.
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	d,80h
		add	hl,de
		
                and     3                       ;X offset
                ld      b,a
                ld      a,(iy+12)               ;Lovedek iranya
                or      a
		ld	de,0001000010000000b
                jr      z,bfire.xor_3           ;fuggoleges loves
                ld      e,11110000b             ;kek lovedek
                jp      bfire.xor_0             ;Vizszintes loves

;----------------------------------------------------------------------------
; fire.base - bazis loves inditasa
;----------------------------------------------------------------------------

fire.base:      ld	a,(showbase)		;Bazis latszik?
		or	a
		ret	z
		ld      iy,base.table           ;Bazis adatok
                ld      a,(ammo)                ;Van lovedek?
                or      a
                jr      nz,fire.base_1          ;Igen,ok
                ld      (iy+6),0                ;Loves bill.-k torlese
                ret

fire.base_1:    ld      a,(iy+4)                ;base.firexp
                or      (iy+5)                  ;base.fireyp
                ret     nz                      ;Mar megy a loves

                ld      a,(ix+13)		;Kilepes elotti varakozas
		or	a
		ret	nz
		
                ld      (iy+10),0               ;Lovedek irany torlese
                ld      (iy+11),0               ;(base.firexd, fireyd)

                bit     fire.left,(iy+6)        ;Merre lojon?
                jr      nz,fire.base_10
                bit     fire.right,(iy+6)
                jr      nz,fire.base_11
                bit     fire.up,(iy+6)
                jr      nz,fire.base_12
                bit     fire.down,(iy+6)
                jr      nz,fire.base_13
                ret

                ;Balra

fire.base_10:   ld      a,(iy+1)                ;base.yp
                and     1Fh                     ;Csak akkor lohet, ha vizsz.
                xor     8                       ;-en soron all
                ret     nz

                call    incfire                 ;Lovesek szamolasa
                ld      a,(iy+0)                ;Bazispoz.bol lovedek poz.
                sub     4                       ;szamolasa
                ld      (iy+4),a                ;base.firexp <- base.xp-4
                ld      a,(iy+1)
                add     a,7
                ld      (iy+5),a                ;base.fireyp <- nase.yp+7
                ld      (iy+10),-4              ;base.firexd
                jp      bfire.xor

                ;Jobbra

fire.base_11:   ld      a,(iy+1)
                and     1Fh
                xor     8
                ret     nz

                call    incfire
                ld      a,(iy+0)
                add     a,16
                ld      (iy+4),a                ;base.firexp <- base.xp+16
                ld      a,(iy+1)
                add     a,7
                ld      (iy+5),a                ;base.fireyp <- base.yp+7
                ld      (iy+10),4
                jp      bfire.xor

                ;Fel

fire.base_12:   ld      a,(iy+0)
                and     1Fh
                xor     8
                ret     nz

                call    incfire
                ld      a,(iy+0)
                add     a,7
                ld      (iy+4),a                ;base.firexp <- base.xp+7
                ld      a,(iy+1)
                sub     4
                ld      (iy+5),a                ;base.fireyp <- base.yp-4
                ld      (iy+11),-4
                jp      bfire.xor

fire.base_13:   ld      a,(iy+0)
                and     1Fh
                xor     8
                ret     nz

                call    incfire
                ld      a,(iy+0)
                add     a,7
                ld      (iy+4),a                ;base.firexp <- base.xp+7
                ld      a,(iy+1)
                add     a,16
                ld      (iy+5),a                ;base.fireyp <- base.yp+16
                ld      (iy+11),4
                jp      bfire.xor

;----------------------------------------------------------------------------
; incfire - increment fire counter (valtozik az rnd es bonusz gen, ammo)
;----------------------------------------------------------------------------

incfire:        ld      a,(firecount)           ;Lovesekszamolasa
                cp      60h
                jr      nc,incfire_1            ;96-ig szamolja, ez befolya-
                inc     a                       ;solja az ellensegekviselke-
                ld      (firecount),a           ;deset

incfire_1:      call    incfire_3               ;Loszer figyelese

                ld      ix,bonus.table          ;Bonusz adatok
                ld      a,(ix+16)               ;Bonusz lehetseges?
                or      a                       
                ret     m                       ;Nem, letiltva

                dec     (ix+17)                 ;Bonusz counter
                jr      nz,incfire_2            ;Lejart? ( nem, --> )

                ;Nem lett idoben felvevea bonusz, letiltja

                ld      c,(ix+16)               ;Melyik bonusz volt kint?
                ld      b,0
                add     ix,bc                   ;Rakeres

                ld      d,(ix+0)                ;Torli a kintlevo bonuszt
                ld      e,(ix+8)
                call    clr.bonus

                ld      d,(ix+0)                ;Visszateszi a hazba
                ld      e,(ix+4)
                call    draw.bonus
                ld      (ix+16),-1              ;Letiltja
		xor	a
		ld	(bonus.out),a
                ret

incfire_2:      ld      a,(ix+17)               ;Kiadja?
                cp      12
                ret     nz

                ld      c,(ix+16)               ;Melyik bonusz?
                ld      b,0
                add     ix,bc                   ;Rakeres

                ld      d,(ix+0)                ;Torli a hazbol
                ld      e,(ix+4)
                call    clr.bonus

                ld      d,(ix+0)                ;Kirakja
                ld      e,(ix+8)
		ld	(bonus.addr),de
		ld	a,1
		ld	(bonus.out),a
                jp      draw.bonus

                ;Loszer figyelese

incfire_3:      ld      a,(ammo)                ;Van meg loszer?
                or      a
                ret     z                       ;Nincs, de mar kint van a kep

                dec     a
                ld      (ammo),a                ;Csokkenti
                cp      8
                ret     nz                      ;Ha mar csak 8 maradt kirakja
                                                ;a felvehetot

                call    rnd                     ;Hova tegye?
                and     15
                ld      c,a
                ld      b,0
                ld      ix,ammo.xtbl            ;Tablazatbol veszia poz.-t
                add     ix,bc

                ld      a,(ix+0)
                ld      d,a
                ld      (ammo.xpos),a
                ld      a,(ix+16)
                ld      e,a
                ld      (ammo.ypos),a
                jp      draw.ammo               ;Kirajzolja

                ;Az esetleg kintmaradt bonuszt torli

redraw.bonus:   ld      ix,bonus.table          ;Bonusz adatok
                ld      a,(ix+16)               ;Letiltva?
                or      a
                ret     m                       ;Igen, nem lehet kint

                ld      a,(ix+17)               ;Ki lett adva?
                cp      13
                ret     nc                      ;Meg nem, nincs kint

                ld      c,(ix+16)               ;Torli a keprol
                ld      b,0
                add     ix,bc
                ld      d,(ix+0)
                ld      e,(ix+8)
                call    clr.bonus
		xor	a
		ld	(bonus.out),a
		ret

;----------------------------------------------------------------------------
; bonus.scr - Bonusz fel lett veve, bonus score kiirasa es pontozas
;
; 100,200,400,800 pontokat ad
;----------------------------------------------------------------------------

bonus.scr:      ld      ix,bonus.table          ;Bonusz adatok
                ld      (ix+17),24              ;Uj szamlalo
                ld      (ix+18),48              ;Pontszam meddig maradjon kint

                ld      c,(ix+16)               ;Hova lesz kiteve
                ld      (ix+21),c
		ld	a,c
                ld      (bscorechr),a

                inc     (ix+16)                 ;Kovetkezo bonusz lesz a
                ld      a,(ix+16)               ;soros
                cp      4                       ;Van meg?
                jr      c,bonus.scr_1           ;Igen, ok
                ld      (ix+16),-1              ;Nincstobb, letiltja

bonus.scr_1:    ld      b,0                     ;Pontszam elo
                ld      hl,bscore
                add     hl,bc
                ld      a,(hl)
                add     ix,bc
                call    addscore                ;Pontozas

                ld      d,(ix+0)                ;Torli a bonuszt a keprol
                ld      e,(ix+8)
                push    de
                call    clr.bonus
		xor	a
		ld	(bonus.out),a
                pop     de

                ld      d,(ix+0)                ;Torli a bonuszt a keprol
                ld      e,(ix+8)
		srl	d
		srl	d
		
		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	e,d
		ld	d,80h
		add	hl,de
		ex	de,hl
		
                ld      (bscoreaddr),de         ;Hova es mit tesz ki

set.bonusscr:   ld	a,(bscorechr)
		ld	de,(bscoreaddr)
		ld      l,a
                ld      h,0
                inc     d                       ;y+4
                ld      bc,bscore.chr           ;Szam mintaja
                add     hl,hl                   ;*32
                add     hl,hl
                add     hl,hl
                add     hl,hl
                add     hl,hl
                add     hl,bc
                push    hl
                pop     iy                      ;Minta cime
                ex      de,hl
                ld      b,7                     ;7 pixel magas
                push    iy
		ld	a,0ffh
		ld	(showbonus),a
                jp      draw.bonus_0

                ;torli a bonusz pontszamot

clr.bonusscr:   ld      de,(bscoreaddr)         ;Hova lett kiteve?
		xor	a
		ld	(showbonus),a
		ld	a,(bscorechr)
		ld      l,a
                ld      h,0
                inc     d                       ;y+4
                ld      bc,bscore.chr           ;Szam mintaja
                add     hl,hl                   ;*32
                add     hl,hl
                add     hl,hl
                add     hl,hl
                add     hl,hl
                add     hl,bc
                push    hl
                pop     iy                      ;Minta cime
                ex      de,hl
                ld      b,7                     ;7 pixel magas
                push    iy
		xor	a
		ld	(showbonus),a
                jp      clr.bonusscr_0

;----------------------------------------------------------------------------
; move.base - Bazis mozgatasa
;----------------------------------------------------------------------------

move.base:      ld      iy,base.table           ;Bazis adatok
                ld      a,(exitcode)            ;Ellensegek kilove?
                cp      3
                jr      z,move.base_1                    ;Igen, mozoghat

                ld      a,(iy+13)               ;Kilottek? (delay megy?)
                or      a
                ret     nz

move.base_1:             ld      a,(iy+7)                ;movekeys
                or      a
                jr      z,move.base_10                   ;Van uj irany?

                bit     move.stop,(iy+7)
                call    nz,move.base_24
                bit     move.up,(iy+7)
                call    nz,move.base_20
                bit     move.down,(iy+7)
                call    nz,move.base_21
                bit     move.left,(iy+7)
                call    nz,move.base_22
                bit     move.right,(iy+7)
                call    nz,move.base_23

                ;Mozgatas

move.base_10:            ld      a,(iy+0)                ;base.xpos
                add     a,(iy+2)                ;+base.xdir
                cp      29h                     ;Bal szelere ert?
                jr      nc,move.base_11
                ld      a,28h                   ;Igen, megallitja
                ld      (iy+2),0

move.base_11:            cp      0C8h                    ;Jobb szelere ert?
                jr      c,move.base_12
                ld      a,0C8h                  ;Igen, megallitja
                ld      (iy+2),0
move.base_12:            ld      (iy+0),a                ;Uj xpos

                ld      a,(iy+1)                ;base.ypos
                add     a,(iy+3)                ;+base.ydir
                cp      49h                     ;Felert?
                jr      nc,move.base_13
                ld      a,48h                   ;Igen, megallitja
                ld      (iy+3),0

move.base_13:            cp      0C8h                    ;Aljara ert?
                jr      c,move.base_14
                ld      a,0C8h                  ;Igen, megallitja
                ld      (iy+3),0
move.base_14:            ld      (iy+1),a                ;Uj Ypos
                ret

                ;Felfele

move.base_20:            ld      a,(iy+0)                ;X pos oszlopon?
                and     1Fh
                xor     8
                ret     nz                      ;Nem, nem mehet fel

                ld      (iy+2),a                ;x,y iranyok torlese
                ld      (iy+3),a
                res     move.up,(iy+7)          ;Billentyuk torlese
                res     move.down,(iy+7)
                ld      a,(iy+1)                ;Legfelul van?
                cp      28h
                ret     z                       ;Igen, nem engedi tovabb
                dec     (iy+3)                  ;ydir = -1
                ret

                ;Lefele

move.base_21:            ld      a,(iy+0)
                and     1Fh
                xor     8
                ret     nz
                ld      (iy+2),a
                ld      (iy+3),a
                res     move.up,(iy+7)
                res     move.down,(iy+7)
                ld      a,(iy+1)
                cp      0C8h
                ret     z
                inc     (iy+3)                  ;ydir = 1
                ret

                ;Balra

move.base_22:            ld      a,(iy+1)
                and     1Fh
                xor     8
                ret     nz
                ld      (iy+2),a
                ld      (iy+3),a
                res     move.left,(iy+7)
                res     move.right,(iy+7)
                ld      a,(iy+0)
                cp      028h
                ret     z
                dec     (iy+2)                  ;xdir = -1
                ret

                ;Jobbra

move.base_23:            ld      a,(iy+1)
                and     1Fh
                xor     8
                ret     nz
                ld      (iy+2),a
                ld      (iy+3),a
                res     move.left,(iy+7)
                res     move.right,(iy+7)
                ld      a,(iy+0)
                cp      0C8h
                ret     z
                inc     (iy+2)                  ;xdir = 1
                ret

                ;Stop

move.base_24:   ld      a,(iy+1)                ;Keresztezodesben all?
                and     1Fh
                xor     8
                ret     nz
                ld      a,(iy+0)
                and     1Fh
                xor     8
                ret     nz
                ld      (iy+7),a                ;Igen, billentyuk es
                ld      (iy+2),a                ;mozgas torlese
                ld      (iy+3),a
                ret

;----------------------------------------------------------------------------
; inkey - billentyuk dekodolasa
;----------------------------------------------------------------------------

getkey:		out	(03h),a
		nop
		nop
		in	a,(58h)
		cpl
		ret

kbdconv1:	push	bc
		ld	b,a
		xor	a
		bit	0,b			;E
		jr	z,kbdconv1a
		set	5,a
kbdconv1a:	bit	1,b			;D
		jr	z,kbdconv1b
		set	4,a
kbdconv1b:	bit	2,b			;S
		jr	z,kbdconv1c
		set	3,a
kbdconv1c:	bit	7,b			;F
		jr	z,kbdconv1d
		set	6,a
kbdconv1d:	pop	bc
		ret

kbdconv2:	push	bc
		ld	b,a
		xor	a
		bit	0,b			;I1
		jr	z,kbdconv2a
		set	1,a
kbdconv2a:	bit	1,b			;K3
		jr	z,kbdconv2b
		set	3,a
kbdconv2b:	bit	2,b			;L4
		jr	z,kbdconv2c
		set	4,a
kbdconv2c:	bit	7,b			;J2
		jr	z,kbdconv2d
		set	2,a
kbdconv2d:	bit	5,b			;SPC
		jr	z,kbdconv2e
		set	7,a
kbdconv2e:	pop	bc
		ret

inkey:          ld      iy,base.table
                ld      a,(exitcode)            ;Ellensegek kilove?
                cp      3
                jr      z,inkey_0               ;Igen, meg mozoghat

                ld      a,(iy+13)               ;Bazis kilove? (delay megy?)
                or      a
                ret     nz                      ;Igen, nincs mozgas, loves

inkey_0:        ld      a,(demo)                ;Demoban van?
                or      a
                jr      nz,inkey_1              ;Igen, veletlen mozgas

;Lovesnel nincs folyamatos loves, minden loveshez ujra le kell nyomni

		ld	a,2
		call	getkey			;<E>
		rrca
		and	00000001b
		ld	b,a
		ld	a,4
		call	getkey			;<D><S><F>
		and	10000110b
		or	b

;                ld      ix,keyboard             ;Billentyuzet
;                ld      a,(ix+01h)              ;<D><E><F>
;                and     01110000b
;                ld      b,a
;                ld      a,(ix+04h)              ;<S>
;                and     00001000b
;                or      b

                ld      b,a                     ;Csak a lenyomaskor 1x
                ld      a,(pkey)                ;Elozo bill. status
                xor     b
                and     b
		call	kbdconv1
		
                or      (iy+6)                  ;Loves irany mentese
                ld      (iy+6),a

                ld      a,b
                ld      (pkey),a

		ld	a,3
		call	getkey			;<I>
		rrca
		and	00000001b
		ld	b,a
		ld	a,5
		call	getkey			;<J><K><L>
		and	10000110b
		or	b
		ld	b,a
		ld	a,7			;<SPC>
		call	getkey
		and	00100000b
		or	b
		call	kbdconv2
		
		
;                ld      a,(ix+02h)              ;<I><J><K><L>
;                and     00011110b
;                ld      b,a
;                ld      a,(ix+40h)              ;<Space>
;                and     10000000b
;                or      b


                or      (iy+7)                  ;Mozgato bill.-k
                ld      (iy+7),a
                ret

                ;Demo modban

inkey_1:        dec     a                       ;Demo counter
                ld      (demo),a
                ret     nz                      ;Uj bill. johet?

                call    rnd                     ;Demo counter ujrainditasa
                and     127
                add     a,16
                ld      (demo),a

                call    rnd                     ;Loves
                ld      b,00001000b
                call    inkey_2
                ld      a,b
                or      (iy+6)
                ld      (iy+6),a

                call    rnd                     ;Mozgas
                ld      b,00000010b
                call    inkey_2
                ld      a,b
                or      (iy+7)
                ld      (iy+7),a
                ret

inkey_2:        and     3                       ;Melyik bill legyen?
                ret     z
                rlc     b
                dec     a
                jr      inkey_2

;----------------------------------------------------------------------------
; print.score - pontszam kiirasa
;----------------------------------------------------------------------------

print.score:    ld      hl,score
                ld      de,000Ch + 8000h
                ld      b,6
                jp      txtout

;----------------------------------------------------------------------------
; print.pause - Pause
;----------------------------------------------------------------------------

print.pause:    ld      hl,txt.pause
;               ld      de,21*64+1bh + 08000h
                ld      de,21*64+36h + 08000h
                ld      b,5
                jp      txtout_red

;----------------------------------------------------------------------------
; clr.pause - Pause torlese
;----------------------------------------------------------------------------

clr.pause:      ld      b,5
;               ld      de,21*64+1bh + 08000h
                ld      de,21*64+36h + 08000h
clr.pause_1:    ld      a,21
                call    chrout
                djnz    clr.pause_1
                ret

;----------------------------------------------------------------------------
; print.high - high score kiirasa
;----------------------------------------------------------------------------

print.high:     ld      hl,highscore
                ld      de,0034h + 8000h
                ld      b,6
                jp      txtout

;----------------------------------------------------------------------------
; print.lives - eletek kiirasa
;----------------------------------------------------------------------------

print.lives:    ld      hl,lives
                ld      de,21*64+6 + 8000h
                ld      b,2
                jp      txtout

;----------------------------------------------------------------------------
; set.lives - A elet beallitasa
;----------------------------------------------------------------------------

set.lives:      ld      (lives+1),a
                xor     a
                ld      (lives),a
                ret

;----------------------------------------------------------------------------
; inc.lives - Ad egy eletet (minden 10000 pontnal)
;----------------------------------------------------------------------------

inc.lives:      ld      b,2

inc.lives_1:    push    bc
                ld      c,80                    ;rovid hangeffect
                call    xbase.effect

                ld      c,80                    ;rovid effect
                call    xbase.effect

                pop     bc
                djnz    inc.lives_1             ;2x

                ld      c,255                   ;hosszu melyulo effect
                call    xbase.effect


                ld      hl,lives+1              ;Eletek novelese
                ld      a,(hl)
                cp      9
                jr      z,inc.lives_2
                inc     (hl)
                jp      print.lives

inc.lives_2:    dec     hl
                ld      a,(hl)
                cp      9
                ret     z                       ;99 eletnel nem lehet tobb
                inc     (hl)
                inc     hl
                ld      (hl),0
                jp      print.lives

;----------------------------------------------------------------------------
; dec.lives - Elvesz egy eletet
;----------------------------------------------------------------------------

dec.lives:      ld	a,(demo)
		or	a
		ret	nz
		ld      hl,lives+1
                dec     (hl)
                jp      p,dec.lives_1
                ld      (hl),9
                dec     hl
                dec     (hl)
                inc     hl
dec.lives_1:    ld      a,(hl)
                dec     hl
                or      (hl)
                jp      print.lives

;----------------------------------------------------------------------------
; extra base hangeffect
;----------------------------------------------------------------------------

xbase.effect:   ld      d,1
                ld	a,81h
xbase.effect_1: ld      e,d
xbase.effect_2: dec     e
                jr      nz,xbase.effect_2
                xor     1ch
                out     (speaker),a
                inc     d
                dec     c
                jr      nz,xbase.effect_1
                ld	a,81h
                out     (speaker),a
                ret

ammo.effect:    ld      hl,ammoeff
                ld      a,(hl)
                or      a
                ret     z

                dec     (hl)
                rrca
                ret     c
                ld      c,a
                ld      b,0
                ld      ix,ammoeff.dat
                add     ix,bc
                ld      d,(ix+0)
                ld      c,(ix+8)

                ld	a,81h
ammo.effect_1:  ld      e,d
ammo.effect_2:  dec     e
                jr      nz,ammo.effect_2
                xor     1ch
                out     (speaker),a

                ld      e,d
ammo.effect_3:  dec     e
                jr      nz,ammo.effect_3
                xor     1ch
                out     (speaker),a

                inc     d
                dec     c
                jr      nz,ammo.effect_1
                ld	a,81h
                out     (speaker),a
                ret

ammoeff.dat:    db      1,10,20,30,35,40,45,50  ;Magassag
                db      32,30,26,22,18,14,10,6  ;Hossz
                dw      0

;----------------------------------------------------------------------------
; ammo.effect - loszer felvetel hangja
;----------------------------------------------------------------------------

bonus.effect:   ld      d,160                   ;Magasodik
                ld      c,158
                ld	a,81h
bonus.effect_1: ld      e,d
bonus.effect_2: dec     e
                jr      nz,bonus.effect_2
                xor     1ch
                out     (speaker),a
                dec     d
                dec     c
                jr      nz,bonus.effect_1

                ld      d,2                     ;Melyul
                ld      c,158
                ld	a,81h
bonus.effect_3: ld      e,d
bonus.effect_4: dec     e
                jr      nz,bonus.effect_4
                xor     1ch
                out     (speaker),a
                inc     d
                dec     c
                jr      nz,bonus.effect_3
                ld	a,81h
                out     (speaker),a
                ret

;----------------------------------------------------------------------------
; draw.bonus - Dx Ey poz.ba xor-al bonus C szinmaszk
;----------------------------------------------------------------------------

draw.bonus.timer:
                ld      ix,bonus.table          ;Bonusz adatok
                ld      a,(ix+17)               ;Kint van?
                cp      13                      ;12 loves utan teszi ki
                ret     nc

                ld      c,(ix+16)               ;Melyik bonusz?
                ld      b,0
                add     ix,bc                   ;Rakeres

                ld      d,(ix+0)                ;Kirakja
                ld      e,(ix+8)
                jp      draw.bonus

draw.bonus:     inc	e
		inc	e
		inc	e
		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		srl	d
		srl	d
		ld	e,d
		ld	d,80h
		add	hl,de
		
                push    iy
                ld      iy,bonus                ;Bonusz minta
                ld      b,10                    ;10 magas

draw.bonus_0:   ld      de,61                   ;Kov. sor offset

                ;Egy sor kirajzolasa a bonuszbol

draw.bonus_1:   ld      a,(iy+2)
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                or      (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                or      (hl)
                ld      (hl),a
                add     hl,de
		
                inc     iy
                inc     iy
                inc     iy
                inc     iy
                djnz    draw.bonus_1
                pop     iy
                ret

clr.bonusscr_0: ld      de,61                   ;Kov. sor offset

                ;Egy sor kirajzolasa a bonuszbol

clr.bonusscr_1: ld      a,(iy+2)
		cpl
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
		cpl
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
		cpl
                and     (hl)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
		cpl
                and     (hl)
                ld      (hl),a
                add     hl,de
		
                inc     iy
                inc     iy
                inc     iy
                inc     iy
                djnz    clr.bonusscr_1
                pop     iy
                ret

		;----------------------------------------------------------------------------
; drw.allbonus - Osszes bonusz kirajzolasa
;----------------------------------------------------------------------------

drw.allbonus:   ld      ix,bonus.table          ;Bonusz adatok
                ld      c,4                     ;4 bonusz van
drw.allbonus_1: ld      d,(ix+0)                ;Hazon belulre
                ld      e,(ix+4)
                push    bc
                call    draw.bonus
                pop     bc
                inc     ix
                dec     c
                jr      nz,drw.allbonus_1
                ret

;----------------------------------------------------------------------------
; clr.allbonus - Osszes bonusz torlese
;----------------------------------------------------------------------------

clr.allbonus:   ld      ix,bonus.table          ;Bonusz adatok
                ld      c,4                     ;4 bonusz hely van
clr.allbonus_1: ld      d,(ix+0)                ;Hazon beluli poz.
                ld      e,(ix+4)
                call    clr.bonus
                ld      d,(ix+8)                ;Hazon kivuli poz.
                ld      e,(ix+4)
                call    clr.bonus
                inc     ix
                dec     c
                jr      nz,clr.allbonus_1
		xor	a
		ld	(bonus.out),a
                ret

;----------------------------------------------------------------------------
; clr.bonus - Bonusz torlese
;----------------------------------------------------------------------------

clr.bonus:      ;xor	a
		;ld	(bonus.out),a
		inc     e                       ;y+3
                inc     e
                inc     e
                ld      b,10
		
clr.bonus_0:	ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		srl	d
		srl	d
		ld	e,d
		ld	d,80h
		add	hl,de
		
                ld      de,61                   ;Kov. sor offset

clr.bonus_1:    ld      a,(hl)
                and     11001100b               ;Haz oldala marad
                ld      (hl),a
                inc     hl
                ld      (hl),0
                inc     hl
                ld      (hl),0
                inc     hl
                ld      a,(hl)
                and     00110011b
                ld      (hl),a
                add     hl,de
                djnz    clr.bonus_1
                ret

;----------------------------------------------------------------------------
; print.gover - game over kiirasa
;----------------------------------------------------------------------------

print.gover:    ld      hl,txt.gameover
;               ld      de,8ch*64+17h + 08000h
                ld      de,21*64+17h + 08000h
                ld      b,9
                jp      txtout_red

clr.gover:      ld      b,9
                ld      de,21*64+17h + 08000h
clr.gover1:     ld      a,21
                call    chrout
                djnz    clr.gover1
                ret

;----------------------------------------------------------------------------
; txtout - (HL) txt B length D (x) E (y) poz.ba
;----------------------------------------------------------------------------

txtout:         ld      a,(hl)
                inc     hl
		or	a
                call    chrout
                djnz    txtout
                ret

txtout_red:     ld      a,(hl)
                inc     hl
		scf
                call    chrout
                djnz    txtout_red
                ret
		
;----------------------------------------------------------------------------
; chrout - A ch D (x) E (y) poz.ba  D67 page select
;----------------------------------------------------------------------------

calc:		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	a,d
		and	3fh
		ld	e,a
		ld	d,80h
		add	hl,de
		ret
		
chrout:         push    bc
                push    de
                push    hl

		push	af
		
                ld      l,a                     ;Chrgen offset szamolas
                ld      h,0
                add     hl,hl                   ;16 byte/char
                add     hl,hl
                add     hl,hl
                add     hl,hl
                ld      bc,chrgen
                add     hl,bc

                ld      b,7                     ;7 sor van
chrout_1:       pop	af
		push	af
		ld      a,(hl)                  ;2 byte/sor
		jr	nc,chrout_2
		srl	a
		srl	a
		srl	a
		srl	a
		
chrout_2:       ld      (de),a
;		push	hl
;		ld	hl,-7000h
;		add	hl,de
;		ld	(hl),a
;		pop	hl

		inc     hl
		inc	de
		pop	af
		push	af
		ld      a,(hl)                  ;2 byte/sor
		jr	nc,chrout_3
		srl	a
		srl	a
		srl	a
		srl	a
		
chrout_3:       ld      (de),a
;		push	hl
;		ld	hl,-7000h
;		add	hl,de
;		ld	(hl),a
;		pop	hl
                inc     hl
                dec     de
		push	bc
		ld	bc,64
		ex	de,hl
		add	hl,bc
		ex	de,hl
		pop	bc
                djnz    chrout_1
		
		pop	af
                pop     hl
                pop     de
                pop     bc
                inc     de
                inc     de
                ret

;----------------------------------------------------------------------------
; draw.bg - hatter megrajzolasa
;----------------------------------------------------------------------------

draw.left       =       6                       ;(8 + 16) / 4 pixel
draw.top        =       56                      ;(40 + 16)

draw.bg:        ld      h,draw.left
draw.bg_1:      ld      l,draw.top
draw.bg_2:      call    home
                ld      a,l
                add     a,32
                ld      l,a
                cp      draw.top+192
                jr      c,draw.bg_2
                ld      a,h
                add     a,8
                ld      h,a
                cp      draw.left+56
                jr      c,draw.bg_1
                ret

;----------------------------------------------------------------------------
; home - egy haz kirajzolasa H (x) L (y) pozicioba
;----------------------------------------------------------------------------

home:           push    bc
		push	de
                push    hl
		ex	de,hl
		ld	l,e
		ld	e,d
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	d,80h
		add	hl,de
		ld	de,64
		
                call    home_2                  ;Felso sor

                ld      b,14                    ;14 bal es jobb oldal
home_1:         add	hl,de
                ld      (hl),01000100b
                inc     hl
                inc     hl
                inc     hl
                ld      (hl),00100010b          ;2-2 pontbol all
		dec	hl
		dec	hl
		dec	hl
                djnz    home_1

                call    home_2                  ;Also sor
                pop     hl
		pop	de
                pop     bc
                ret

home_2:         ld      a,11111111b
                ld      (hl),01110111b
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),11101110b
		dec	hl
		dec	hl
		dec	hl
                ret

;----------------------------------------------------------------------------
; disp.off - palettat feketere allitja
;----------------------------------------------------------------------------

disp.off:       xor	a
		out	(60h),a
		out	(61h),a
		out	(62h),a
		out	(63h),a
		ld	a,14
		out	(70h),a
		ld	a,0Eh
		out	(71h),a
		ld	a,15
		out	(70h),a
		ld	a,0FFh
		out	(71h),a
                ret

;----------------------------------------------------------------------------
; disp.on - palettat beallitja
;----------------------------------------------------------------------------

disp.on:	ld	a,00h			;fekete
		out	(00h),a
		ld	(retrace),a
		ld	(irqphase),a
		out	(60h),a
		ld	a,11h			;cyan
		out	(61h),a
		ld	a,04h			;red
		out	(62h),a
		ld	a,55h			;white
		out	(63h),a

		ld	a,0c3h
		ld	(0038h),a
		ld	hl,irq
		ld	(0039h),hl
		
		im	1
		ei
		ret

;----------------------------------------------------------------------------
; clear.score - ha nem demo, torli a pontokat
;----------------------------------------------------------------------------

clear.score:    ld      a,(demo)
                or      a
                ret     nz

                ld      hl,score
                ld      de,score+1
                ld      bc,5
                ld      (hl),0
                ldir
                jp      print.score

;----------------------------------------------------------------------------
; clrscr - mindket kepernyot es a buffert torli es bekapcsolja hires-t
;----------------------------------------------------------------------------

cls:            ld      hl,graph.page0          ;Page 0. torlese
                ld      de,graph.page0 +1
                ld      bc,16383
                ld      (hl),0
                ldir
		ret
		
clrscr:         call    disp.off                ;palettat torli
		call	cls

;                ld      hl,1000h	         ;Page backup torlese
;                ld      de,1000h +1
;                ld      bc,16383
;                ld      (hl),0
;                ldir

                ld      hl,txt.score            ;'SCORE'
                ld      de,0000h + 8000h
                ld      b,5
                call    txtout

                ld      hl,txt.high             ;'HIGH SCORE'
                ld      de,001Eh + 8000h
                ld      b,10
                call    txtout

                ret

;----------------------------------------------------------------------------
; print - hl cimrol de-re print, cr + 00h
;----------------------------------------------------------------------------

print:          
		ret

;----------------------------------------------------------------------------
; reset.game - tablazat alaphelyzetbe
;----------------------------------------------------------------------------

reset.game:     ld      hl,default.table
                ld      de,enemy.table
                ld      bc,default.table-enemy.table
                ldir

;----------------------------------------------------------------------------
; reset.table - tablazat alaphelyzetbe
;----------------------------------------------------------------------------

reset.table:    ld      hl,default.table        ;Ellensegek vissza alapba,
                ld      de,enemy.table          ;nem mozognak
                ld      bc,44
                ldir

                ld      hl,base.table           ;Bazis alaphelyzetbe
                ld      (hl),088h
                inc     hl
                ld      (hl),0C8h
                inc     hl
                ld      (hl),0
                ld      de,base.table+3
                ld      bc,10
                ldir
                call    clean                   ;Az esetleg kint maradt
                                                ;lovedekek torlese
                ld      a,(maxammo)             ;Loszer feltoltese
                ld      (ammo),a
                ret

;----------------------------------------------------------------------------
; rnd - veletlenszam generalasa
;
; output: A - veletlenszam
;
; RNDn := (RNDn-1 + RNDn-4 + RNDn-5) Mod 256
;
;----------------------------------------------------------------------------

rnd:            push    ix
                push    hl
                ld      ix,random
                push    de
                ld      a,(ix+1)
                push    bc
                adc     a,(ix+4)
                adc     a,(ix+5)
                ld      (random),a
                ld      hl,random + 4
                ld      de,random + 5
                ld      bc,5
                lddr
                pop     bc
                pop     de
                pop     hl
                pop     ix
                ret

;----------------------------------------------------------------------------
; sprite - IY spr addr D (x) E (y) C (offs)
;
; Nem tul erdekes resz, megprobaltam a leggyorsabb kodot kihozni belole.
; A sprite 4 X fazisa le van generalva, eloszor ebbol valasztja ki a szukse-
; gest. A sprite bal es jobb szele utan 1-1 pixelt meg torol.
;----------------------------------------------------------------------------

sprite:         ld      a,(spr.drawcnt)         ;Idoziteshez, mennyi sprite
                inc     a                       ;lett kirajzolva (ez tart
                ld      (spr.drawcnt),a         ;a legtovabb)

		ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	e,d
		ld	d,80h
		add	hl,de
		
                ld      de,64
                ld      b,16
                xor     a
                inc     c
                dec     c
                jr      z,sprite_10                   ;nincs shift, ket szelet torolni kell
                add     iy,de
                dec     c
                jp      z,sprite_20
                add     iy,de
                dec     c
                jp      z,sprite_30
                add     iy,de
                jp      sprite_40

sprite_10:      ld      e,4
                ld      c,01110111b
sprite_11:      dec     hl
                ld      a,(hl)
                and     11101110b
                ld      (hl),a
                inc     hl
                ld      a,(iy+2)
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                ld      (hl),a
                inc     hl
                ld      a,(hl)
                and     c
                ld      (hl),a
		push	bc
		ld	bc,60
		add	hl,bc
		pop	bc
                add     iy,de
                djnz    sprite_11
                jp	sprexit

sprite_20:      ld      e,4
sprite_21:      ld      a,(iy+2)
                ld      c,a
                and     01110111b
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                ld      (hl),a
                inc     hl
                ld      a,c
                and     10001000b
                ld      c,a
                ld      a,(hl)
                and     00110011b
                or      c
                ld      (hl),a
		push	bc
		ld	bc,60
		add	hl,bc
		pop	bc
                add     iy,de
                djnz    sprite_21
                jp	sprexit

sprite_30:      ld      e,4
sprite_31:      ld      a,(iy+2)
                and     00110011b
                ld      c,a
                ld      a,(hl)
                and     10001000b
                or      c
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                ld      (hl),a
                inc     hl
                ld      a,(iy+2)
                and     11001100b
                ld      c,a
                ld      a,(hl)
                and     00010001b
                or      c
                ld      (hl),a
		push	bc
		ld	bc,60
		add	hl,bc
		pop	bc
                add     iy,de
                djnz    sprite_31
                jp	sprexit

sprite_40:      ld      e,4
sprite_41:      ld      a,(iy+2)
                and     00010001b
                ld      c,a
                ld      a,(hl)
                and     11001100b
                or      c
                ld      (hl),a
                inc     hl
                ld      a,(iy+3)
                ld      (hl),a
                inc     hl
                ld      a,(iy+0)
                ld      (hl),a
                inc     hl
                ld      a,(iy+1)
                ld      (hl),a
                inc     hl
                ld      a,(iy+2)
                and     11101110b
                ld      (hl),a
		push	bc
		ld	bc,60
		add	hl,bc
		pop	bc
                add     iy,de
                djnz    sprite_41

sprexit:	ld	a,(ammoon)
		or	a
		ret	z
		call	redraw.ammo
                ret

;----------------------------------------------------------------------------
; clean - ottmaradt lovedek eltakaritasa
;
; 16x16-os mezoket torol, kiveve a hazakat. Ha demo, a game overt is kiirja
;----------------------------------------------------------------------------

clean:          xor	a
		ld	(ammoon),a
		ld	(showbonus),a
;		ld	(bonus.out),a

		ld      d,08h
clean_1:        ld      e,28h
clean_2:        call    clean_3
                ld      a,e
                add     a,10h
                ld      e,a
                cp      0F8h
                jr      c,clean_2
                ld      a,d
                add     a,10h
                ld      d,a
                cp      0F8h
                jr      nz,clean_1

		call	clr.gover
		;govertext:
		ld      a,(demo)
                or      a
                ret     z
		xor	a
 		ld	(bonus.out),a
                jp      print.gover

clean_3:        ld      a,d
                and     10h
                jr      z,clean_5
                ld      a,e
                and     10h
                ret     nz
;d=x, e=y
clean_5:	ld	l,e
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	a,d
		srl	a
		srl	a
		or	l
		ld	l,a
		ld	a,h
		or	a,80h
		ld	h,a
		
                ld      b,8
                xor     a
		push	de
		ld	de,61
clean_4:        ld      (hl),a
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),a
                add	hl,de
                ld      (hl),a
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),a
                inc     hl
                ld      (hl),a
                add	hl,de
                djnz    clean_4
		pop	de
                ret

;----------------------------------------------------------------------------
; genspr - IY sprite fazisok generalasa
;----------------------------------------------------------------------------

genspr:         ld	a,(firstrun)
		or	a
		ret	nz
		call    genspr_1
                call    genspr_1

genspr_1:       push    iy
                pop     ix
                ld      bc,64
                add     ix,bc
                ld      b,16
genspr_2:       xor     a
                ld      h,(iy+1)
                ld      l,(iy+0)
                ld      d,(iy+3)
                ld      e,(iy+2)
                ex      de,hl
                add     hl,hl
                ex      de,hl
                adc     hl,hl
                rla
                ex      de,hl
                add     hl,hl
                ex      de,hl
                adc     hl,hl
                rla
                or      e
                ld      (ix+1),h
                ld      (ix+0),l
                ld      (ix+3),d
                ld      (ix+2),a
                ld      de,4
                add     ix,de
                add     iy,de
                djnz    genspr_2
                ret

;----------------------------------------------------------------------------
; snd.noise - robbanas hangja (B)
;----------------------------------------------------------------------------

snd.noise:      push    bc
                push    de

                ld	a,81h
                ex      af,af'
snd.noise_3:    ld      e,b
                call    rnd
snd.noise_4:    dec     e
                jr      z,snd.noise_5
                srl     a
                jr      snd.noise_4

snd.noise_5:    or      a
snd.noise_6:    jr      z,snd.noise_7
                dec     a
                jr      snd.noise_6

snd.noise_7:    ex      af,af'
                xor     1ch
                out     (speaker),a
                ex      af,af'

                dec     c
                jr      nz,snd.noise_3
                pop     de
                pop     bc
                ld	a,81h
                out     (speaker),a
                ret

;----------------------------------------------------------------------------
genchr:		ld	a,(firstrun)
		or	a
		ret	nz
		dec	a
		ld	(firstrun),a

		call	convspr
		
		ld	bc,24*16
		ld	hl,chrgen
genchr_1:	push	bc
		ld	a,(hl)
		ld	c,0
		and	a,11000000b
		jr	z,genchr_2
		ld	a,c
		or	00010000b
		ld	c,a
		
genchr_2:	ld	a,(hl)
		and	a,00110000b
		jr	z,genchr_3
		ld	a,c
		or	00100000b
		ld	c,a
		
genchr_3:	ld	a,(hl)
		and	a,00001100b
		jr	z,genchr_4
		ld	a,c
		or	01000000b
		ld	c,a
		
genchr_4:	ld	a,(hl)
		and	a,00000011b
		jr	z,genchr_5
		ld	a,c
		or	10000000b
		ld	c,a
		
genchr_5:	ld	(hl),c
		inc	hl
		pop	bc
		dec	bc
		ld	a,b
		or	c
		jr	nz,genchr_1
		ret

convspr:	ld	bc,chrgen-base
		ld	hl,base
convspr1:	ld	e,(hl)
		xor	a
		bit	7,e
		jr	z,convspr2
		or	a,01h
convspr2:	bit	6,e
		jr	z,convspr3
		or	a,10h
convspr3:	bit	5,e
		jr	z,convspr4
		or	a,02h
convspr4:	bit	4,e
		jr	z,convspr5
		or	a,20h
convspr5:	bit	3,e
		jr	z,convspr6
		or	a,04h
convspr6:	bit	2,e
		jr	z,convspr7
		or	a,40h
convspr7:	bit	1,e
		jr	z,convspr8
		or	a,08h
convspr8:	bit	0,e
		jr	z,convspr9
		or	a,80h
convspr9:	ld	(hl),a
		inc	hl
		dec	bc
		ld	a,b
		or	c
		jr	nz,convspr1
		ret

bigchar.base	=	8404h
text.base	=	0a000h
text.data:	db	2,15,"Q@QUIT"
		db	48,15,"P@PAUSE"
		db	17,17,"E"
		db	43,17,"I"
		db	10,19,"S@FIRE@F"
		db	17,21,"D"
		db	43,21,"K"
		db	36,19,"J@MOVE@L"
		db	44,23,"RET@START"
		db	18,25,"PRESS@ANY@KEY"
		db	2,28,"PROGRAM@ZKA"
		db	4,29,"MUSIC@@DOBERDO@BROTHERS"
		db	0

box.data:	db	2,15,2
		db	48,15,2
		db	17,17,2
		db	43,17,2
		db	10,19,2
		db	24,19,2
		db	17,21,2
		db	43,21,2
		db	36,19,2
		db	50,19,2
		db	44,23,6
		db	0
		
box.draw:	ld	de,box.data
box.draw1:	ld	a,(de)
		inc	de
		or	a
		ret	z
		ld	c,a
		ld	b,80h
		ld	a,(de)
		inc	de
		ld	h,a
		ld	l,0
		add	hl,hl
		add	hl,bc
		ld	bc,129
		or	a
		sbc	hl,bc
		ld	a,(de)
		inc	de
		ld	b,a
		
		push	de
		call	box.line1
		ld	a,9
box.draw2:	call	box.line3
		dec	a
		jr	nz,box.draw2
		call	box.line1
		pop	de
		jr	box.draw1
		
box.line1:	ld	c,b
		push	hl
		ld	(hl),00110000b
		inc	hl
box.line2:	ld	(hl),11110000b
		inc	hl
		djnz	box.line2
		ld	(hl),11000000b
		pop	hl
		ld	b,c
		ld	de,64
		add	hl,de
		ret
		
box.line3:	ld	c,b
		push	hl
		ld	(hl),00100000b
		inc	hl
box.line4:	inc	hl
		djnz	box.line4
		ld	(hl),01000000b
		pop	hl
		ld	b,c
		ld	de,64
		add	hl,de
		ret
		
		
		
text.print:	ld	de,text.data
text.print1:	ld	a,(de)
		inc	de
		or	a
		ret	z
		
		cp	40h
		jr	nc,text.print2
		ld	c,a
		ld	b,80h
		ld	a,(de)
		ld	l,0
		ld	h,a
		add	hl,hl
		add	hl,bc
		inc	de
		jr	text.print1
		
text.print2:	call	putc
		jr	text.print1

intro:		call	cls
		ld	a,0a8h			;sarga
		out	(00h),a
		rrca
		out	(60h),a
		xor	a
		out	(61h),a
		out	(62h),a
		out	(63h),a

		ld	hl,bigchar.base
		ld	de,char.c
		call	bigchar
		ld	hl,bigchar.base+10
		ld	de,char.r
		call	bigchar
		ld	hl,bigchar.base+20
		ld	de,char.o
		call	bigchar
		ld	hl,bigchar.base+30
		ld	de,char.s
		call	bigchar
		ld	hl,bigchar.base+40
		ld	de,char.s
		call	bigchar
		ld	hl,bigchar.base+50
		ld	de,char..
		call	bigchar

		ld	hl,bigchar.base+48*64+20
		ld	de,char.f
		call	bigchar
		ld	hl,bigchar.base+48*64+30
		ld	de,char.i
		call	bigchar
		ld	hl,bigchar.base+48*64+38
		ld	de,char.r
		call	bigchar
		ld	hl,bigchar.base+48*64+48
		ld	de,char.e
		call	bigchar

		call	text.print
		call	box.draw
		call	MainPrg
		
bigchar.wait:	call	bigchar.key
		jr	z,bigchar.wait
bigchar.wait1:	call	bigchar.key
		jr	nz,bigchar.wait1
		xor	a
		out	(00h),a
		out	(60h),a
		ret
		
bigchar.key:	ld	bc,0900h
bigchar.key1:	ld	a,b
		call	getkey
		or	c
		ld	c,a
		dec	b
		jp	p,bigchar.key1
		ld	a,c
		or	a
		ret
		


bigchar:	ld	b,5
bigchar0:	ld	a,(de)
		call	bigchar1
		call	bigchar1
		inc	de
		ld	a,(de)
		call	bigchar1
		call	bigchar1
		inc	de
		dec	hl
		dec	hl
		dec	hl
		dec	hl
		dec	hl
		dec	hl
		dec	hl
		dec	hl
		inc	h
		inc	h
		djnz	bigchar0
		ret
		
bigchar1:	push	bc
		push	de
		push	hl
		rrca
		rrca
		rrca
		rrca
		push	af
		and	a,07h
		ex	de,hl
		ld	l,a
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	bc,bitmaps
		add	hl,bc
		ex	de,hl
		
		ld	b,8
bigchar2:	push	bc
		ld	bc,63
		ld	a,(de)
		and	0f0h
		ld	(hl),a
		inc	hl
		ld	a,(de)
		and	0fh
		ld	(hl),a
		add	hl,bc
		inc	de
		pop	bc
		djnz	bigchar2
		
		pop	af
		pop	hl
		pop	de
		pop	bc
		inc	hl
		inc	hl
		ret
		


char.c:		db	21h,13h,10h,00h,10h,00h,10h,00h,41h,15h
char.r:		db	11h,13h,10h,01h,11h,15h,10h,43h,10h,01h
char.o:		db	21h,13h,10h,01h,10h,01h,10h,01h,41h,15h
char.s:		db	21h,13h,10h,00h,41h,13h,00h,01h,41h,15h
char..:		db	00h,00h,00h,00h,01h,10h,00h,00h,00h,00h
char.f:		db	11h,11h,10h,00h,11h,10h,10h,00h,10h,00h
char.i:		db	11h,10h,01h,00h,01h,00h,01h,00h,11h,10h
char.e:		db	11h,11h,10h,00h,11h,10h,10h,00h,11h,11h
		
bitmaps:	db	000h,000h,000h,000h,000h,000h,000h,000h
		db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
		db	000h,001h,003h,007h,00fh,01fh,03fh,07fh
		db	000h,080h,0c0h,0e0h,0f0h,0f8h,0fch,0feh
		db	0ffh,07fh,03fh,01fh,00fh,007h,003h,001h
		db	0ffh,0feh,0fch,0f8h,0f0h,0e0h,0c0h,080h
		
cbmchars:	db      000h,000h,000h,000h,000h,000h,000h,000h,018h,03Ch,066h,07Eh,066h,066h,066h,000h
		db      07Ch,066h,066h,07Ch,066h,066h,07Ch,000h,03Ch,066h,060h,060h,060h,066h,03Ch,000h
		db      078h,06Ch,066h,066h,066h,06Ch,078h,000h,07Eh,060h,060h,078h,060h,060h,07Eh,000h
		db      07Eh,060h,060h,078h,060h,060h,060h,000h,03Ch,066h,060h,06Eh,066h,066h,03Ch,000h
		db      066h,066h,066h,07Eh,066h,066h,066h,000h,03Ch,018h,018h,018h,018h,018h,03Ch,000h
		db      01Eh,00Ch,00Ch,00Ch,00Ch,06Ch,038h,000h,066h,06Ch,078h,070h,078h,06Ch,066h,000h
		db      060h,060h,060h,060h,060h,060h,07Eh,000h,063h,077h,07Fh,06Bh,063h,063h,063h,000h
		db      066h,076h,07Eh,07Eh,06Eh,066h,066h,000h,03Ch,066h,066h,066h,066h,066h,03Ch,000h
		db      07Ch,066h,066h,07Ch,060h,060h,060h,000h,03Ch,066h,066h,066h,066h,03Ch,00Eh,000h
		db      07Ch,066h,066h,07Ch,078h,06Ch,066h,000h,03Ch,066h,060h,03Ch,006h,066h,03Ch,000h
		db      07Eh,018h,018h,018h,018h,018h,018h,000h,066h,066h,066h,066h,066h,066h,03Ch,000h
		db      066h,066h,066h,066h,066h,03Ch,018h,000h,063h,063h,063h,06Bh,07Fh,077h,063h,000h
		db      066h,066h,03Ch,018h,03Ch,066h,066h,000h,066h,066h,066h,03Ch,018h,018h,018h,000h
		db	07Eh,006h,00Ch,018h,030h,060h,07Eh,000h

;input: A - char, HL disp pos
		
putc:		push	de
		push	hl
		ex	de,hl
		ld	l,a
		ld	h,0
		add	hl,hl
		add	hl,hl
		add	hl,hl
		ld	bc,cbmchars-40h*8
		add	hl,bc
		ex	de,hl
		ld	b,8
putc1:		ld	a,(de)
		inc	de
		push	bc
		ld	c,a
		and	0f0h
		ld	(hl),a
		inc	hl
		ld	a,c
		and	0fh
		ld	(hl),a
		ld	bc,63
		add	hl,bc
		pop	bc
		djnz	putc1
		pop	hl
		inc	hl
		inc	hl
		pop	de
		ret		
		
;----------------------------------------------------------------------------
random:         db      'RANDOM'

;txt.switchto:   db      'Crossfire v1.1b. Copyright (C) Kollar Zoltan, 2005.',13,13
;                db      'Switch to Micolor 01 display',13
;                db      '   Real-80 emulator: F4 key',13,13
;                db      'Start game: <ENTER>',13
;                db      'Pause game: <CLEAR>',13
;                db      'Reset game: <BREAK> + <CLEAR>',13
;                db      'Directions: Fire        Move',13
;                db      '            <E>         <I>',13
;                db      '         <S>   <F>   <J>< ><L>',13
;                db      '            <D>         <K>',0

txt.gameover:   db      12,17,18,16,21,0,19,16,15

txt.high:       db      10,11,12,10,20
txt.score:      db      13,14,0,15,16
txt.pause:      db      22,17,23,13,16

enemy.sprite:   dw      enemy.empty
                dw      enemy.10pts
                dw      enemy.20pts
                dw      enemy.40pts
                dw      enemy.80pts

;----------------------------------------------------------------------------
enemy.table:
enemy.xpos:     ds      11
enemy.ypos:     ds      11
enemy.xdir:     ds      11
enemy.ydir:     ds      11
enemy.pts:      ds      11

default.table:
default.xpos:   db      038h,058h,078h,098h,0B8h,0D8h,008h,008h,008h,0E8h,0E8h
default.ypos:   db      028h,028h,028h,028h,028h,028h,058h,098h,0D8h,078h,0B8h
default.xdir:   db      0,0,0,0,0,0,0,0,0,0,0
default.ydir:   db      0,0,0,0,0,0,0,0,0,0,0
default.pts:    db      1,1,1,1,1,1,1,1,1,1,1

;----------------------------------------------------------------------------
base.table:
base.xpos:      db      088h            ;+00
base.ypos:      db      0C8h            ;+01
base.xdir:      db      0               ;+02
base.ydir:      db      0               ;+03
base.firexp:    db      0               ;+04
base.fireyp:    db      0               ;+05

firekeys:       db      0               ;+06
movekeys:       db      0               ;+07

firecount:      db      0               ;+08
bonuscount:     db      0               ;+09

base.firexd:    db      0               ;+10
base.fireyd:    db      0               ;+11

base.firephase: db      0               ;+12
delay:          db      0               ;+13

pkey:           db      0               ;+14
bkey:           db      0               ;+15

;----------------------------------------------------------------------------
fire.table:
firexp:         db      0,0,0,0,0,0
fireyp:         db      0,0,0,0,0,0
firexd:         db      0,0,0,0,0,0
fireyd:         db      0,0,0,0,0,0

;----------------------------------------------------------------------------
bonus.table:
bhome.xpos:     db      058h,098h,098h,058h     ;+00
bhome.ypos:     db      098h,098h,078h,078h     ;+04
boutpos:        db      0A8h,0A8h,068h,068h     ;+08
bscore:         db      10,20,40,80             ;+12
bnext:          db      0                       ;+16
bcount:         db      0                       ;+17
bdelay:         db      0                       ;+18
bscoreaddr:     dw      0                       ;+19
bscorechr:      db      0                       ;+21

score:          db      0,0,0,0,0,0
highscore:      db      0,0,0,0,0,0
lives:          db      0,3
ammo:           db      0
maxammo:        db      0
demo:           db      0
exitcode:       db      0
efire.phase:    db      0
ammoeff:        db      0
spr.drawcnt:    db      0
firstrun:	db	0
ammoon:		db	0
ammoaddr:	dw	0
showbonus:	db	0
bonus.out:	db	0
bonus.addr:	dw	0
irqphase:	db	0
retrace:	db	0
showbase:	db	0

ammo.xpos:      db      0
ammo.ypos:      db      0
ammo.xtbl:      db      028h,028h,028h,028h,048h,048h,048h,068h
                db      068h,088h,088h,088h,0A8h,0A8h,0C8h,0C8h
ammo.ytbl:      db      048h,068h,088h,0A8h,048h,068h,0A8h,068h
                db      088h,048h,068h,088h,068h,0A8h,068h,0A8h

hfirel:		db	11111111b,01110111b,00110011b,00010001b
hfirer:		db	00000000b,10001000b,11001100b,11101110b

		

palette:        db      000h,0B0h,0C0h,0FFh,0C0h,0B0h,0C0h,0FFh
                db      07Fh,0B0h,0C0h,0FFh,0FFh,0B0h,0C0h,0FFh

                ;Sprite es karakter adatok
                ;A micolor a 0 bittel kezd balrol ezert tukorkepben lathatok

                include sprite.asm
                include ohno.asm
                include getready.asm
		include gameover.asm
		include cfmusic.asm
		
                end     start
